(define_code_iterator any_extend [ 
 sign_extend
 zero_extend
                                    ])
(define_code_iterator any_shiftrt [ 
 ashiftrt
 lshiftrt
                                     ])
(define_code_iterator any_shift [ 
 ashift
 ashiftrt
 lshiftrt
                                   ])
(define_code_iterator any_div [ 
 div
 udiv
                                 ])
(define_code_iterator any_mod [ 
 mod
 umod
                                 ])
(define_code_iterator fcond [ 
 unordered
 uneq
 unlt
 unle
 eq
 lt
 le
                               ])
(define_code_iterator equality_op [ 
 eq
 ne
                                     ])
(define_code_iterator any_gt [ 
 gt
 gtu
                                ])
(define_code_iterator any_ge [ 
 ge
 geu
                                ])
(define_code_iterator any_lt [ 
 lt
 ltu
                                ])
(define_code_iterator any_le [ 
 le
 leu
                                ])
(define_insn "trap"
[(trap_if (const_int 1) (const_int 0) ) ]
  ""
{
  if (ISA_HAS_COND_TRAP)
    return "teq\t$0,$0";
  else if (TARGET_MIPS16)
    return "break 0";
  else
    return "break";
}
  [(set_attr "type" "trap")]
)

(define_expand "ctrap<mode>4"
[(trap_if  (match_operator 0 "comparison_operator" [  (match_operand:GPR 1 "reg_or_0_operand" "") (match_operand:GPR 2 "arith_operand" "") ]) (match_operand 3 "const_0_operand" "") ) ]
  "ISA_HAS_COND_TRAP"
{
  mips_expand_conditional_trap (operands[0]);
  DONE;
}
)

(define_insn "*conditional_trap<mode>"
[(trap_if  (match_operator:GPR 0 "trap_comparison_operator" [  (match_operand:GPR 1 "reg_or_0_operand" "dJ") (match_operand:GPR 2 "arith_operand" "dI") ]) (const_int 0) ) ]
  "ISA_HAS_COND_TRAP"
  "t%C0\t%z1,%2"
  [(set_attr "type" "trap")]
)



(define_insn "add<mode>3"
[(set (match_operand:ANYF 0 "register_operand" "=f") (plus:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) ) ]
  ""
  "add.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_expand "add<mode>3"
[(set (match_operand:GPR 0 "register_operand" "") (plus:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "arith_operand" "") ) ) ]
  ""
)

(define_insn "*add<mode>3"
[(set (match_operand:GPR 0 "register_operand" "=d,d") (plus:GPR (match_operand:GPR 1 "register_operand" "d,d") (match_operand:GPR 2 "arith_operand" "d,Q") ) ) ]
  "!TARGET_MIPS16"
  "@
    <d>addu\t%0,%1,%2
    <d>addiu\t%0,%1,%2"
  [(set_attr "alu_type" "add")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*add<mode>3_mips16"
[(set (match_operand:GPR 0 "register_operand" "=ks,d,d,d,d") (plus:GPR (match_operand:GPR 1 "register_operand" "ks,ks,0,d,d") (match_operand:GPR 2 "arith_operand" "Q,Q,Q,O,d") ) ) ]
  "TARGET_MIPS16"
  "@
    <d>addiu\t%0,%2
    <d>addiu\t%0,%1,%2
    <d>addiu\t%0,%2
    <d>addiu\t%0,%1,%2
    <d>addu\t%0,%1,%2"
  [(set_attr "alu_type" "add")
   (set_attr "mode" "<MODE>")
   (set_attr_alternative "length"
		[(if_then_else (match_operand 2 "m16_simm8_8")
			       (const_int 4)
			       (const_int 8))
		 (if_then_else (match_operand 2 "m16_uimm<si8_di5>_4")
			       (const_int 4)
			       (const_int 8))
		 (if_then_else (match_operand 2 "m16_simm<si8_di5>_1")
			       (const_int 4)
			       (const_int 8))
		 (if_then_else (match_operand 2 "m16_simm4_1")
			       (const_int 4)
			       (const_int 8))
		 (const_int 4)])]
)


(define_split 
[(set (match_operand:SI 0 "d_operand" "") (plus:SI (match_dup 0) (match_operand:SI 1 "const_int_operand" "") ) ) ]
  "TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) > 0x7f
	&& INTVAL (operands[1]) <= 0x7f + 0x7f)
       || (INTVAL (operands[1]) < - 0x80
	   && INTVAL (operands[1]) >= - 0x80 - 0x80))"
[  (set (match_dup 0) (plus:SI (match_dup 0) (match_dup 1) ) ) (set (match_dup 0) (plus:SI (match_dup 0) (match_dup 2) ) ) ]
{
  HOST_WIDE_INT val = INTVAL (operands[1]);
  if (val >= 0)
    {
      operands[1] = GEN_INT (0x7f);
      operands[2] = GEN_INT (val - 0x7f);
    }
  else
    {
      operands[1] = GEN_INT (- 0x80);
      operands[2] = GEN_INT (val + 0x80);
    }
}
)

(define_split 
[(set (match_operand:SI 0 "d_operand" "") (plus:SI (match_operand:SI 1 "d_operand" "") (match_operand:SI 2 "const_int_operand" "") ) ) ]
  "TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && REGNO (operands[0]) != REGNO (operands[1])
   && ((INTVAL (operands[2]) > 0x7
	&& INTVAL (operands[2]) <= 0x7 + 0x7f)
       || (INTVAL (operands[2]) < - 0x8
	   && INTVAL (operands[2]) >= - 0x8 - 0x80))"
[  (set (match_dup 0) (plus:SI (match_dup 1) (match_dup 2) ) ) (set (match_dup 0) (plus:SI (match_dup 0) (match_dup 3) ) ) ]
{
  HOST_WIDE_INT val = INTVAL (operands[2]);
  if (val >= 0)
    {
      operands[2] = GEN_INT (0x7);
      operands[3] = GEN_INT (val - 0x7);
    }
  else
    {
      operands[2] = GEN_INT (- 0x8);
      operands[3] = GEN_INT (val + 0x8);
    }
}
)

(define_split 
[(set (match_operand:DI 0 "d_operand" "") (plus:DI (match_dup 0) (match_operand:DI 1 "const_int_operand" "") ) ) ]
  "TARGET_MIPS16 && TARGET_64BIT && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) > 0xf
	&& INTVAL (operands[1]) <= 0xf + 0xf)
       || (INTVAL (operands[1]) < - 0x10
	   && INTVAL (operands[1]) >= - 0x10 - 0x10))"
[  (set (match_dup 0) (plus:DI (match_dup 0) (match_dup 1) ) ) (set (match_dup 0) (plus:DI (match_dup 0) (match_dup 2) ) ) ]
{
  HOST_WIDE_INT val = INTVAL (operands[1]);
  if (val >= 0)
    {
      operands[1] = GEN_INT (0xf);
      operands[2] = GEN_INT (val - 0xf);
    }
  else
    {
      operands[1] = GEN_INT (- 0x10);
      operands[2] = GEN_INT (val + 0x10);
    }
}
)

(define_split 
[(set (match_operand:DI 0 "d_operand" "") (plus:DI (match_operand:DI 1 "d_operand" "") (match_operand:DI 2 "const_int_operand" "") ) ) ]
  "TARGET_MIPS16 && TARGET_64BIT && reload_completed && !TARGET_DEBUG_D_MODE
   && REGNO (operands[0]) != REGNO (operands[1])
   && ((INTVAL (operands[2]) > 0x7
	&& INTVAL (operands[2]) <= 0x7 + 0xf)
       || (INTVAL (operands[2]) < - 0x8
	   && INTVAL (operands[2]) >= - 0x8 - 0x10))"
[  (set (match_dup 0) (plus:DI (match_dup 1) (match_dup 2) ) ) (set (match_dup 0) (plus:DI (match_dup 0) (match_dup 3) ) ) ]
{
  HOST_WIDE_INT val = INTVAL (operands[2]);
  if (val >= 0)
    {
      operands[2] = GEN_INT (0x7);
      operands[3] = GEN_INT (val - 0x7);
    }
  else
    {
      operands[2] = GEN_INT (- 0x8);
      operands[3] = GEN_INT (val + 0x8);
    }
}
)

(define_insn "*addsi3_extended"
[(set (match_operand:DI 0 "register_operand" "=d,d") (sign_extend:DI (plus:SI (match_operand:SI 1 "register_operand" "d,d") (match_operand:SI 2 "arith_operand" "d,Q") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16"
  "@
    addu\t%0,%1,%2
    addiu\t%0,%1,%2"
  [(set_attr "alu_type" "add")
   (set_attr "mode" "SI")]
)


(define_insn_and_split "*addsi3_extended_mips16"
[(set (match_operand:DI 0 "register_operand" "=d,d,d") (sign_extend:DI (plus:SI (match_operand:SI 1 "register_operand" "0,d,d") (match_operand:SI 2 "arith_operand" "Q,O,d") ) ) ) ]
  "TARGET_64BIT && TARGET_MIPS16"
  "#"
  "&& reload_completed"
[ (set (match_dup 3) (plus:SI (match_dup 1) (match_dup 2) ) ) ]
  { operands[3] = gen_lowpart (SImode, operands[0]); }
  [(set_attr "alu_type" "add")
   (set_attr "mode" "SI")
   (set_attr "extended_mips16" "yes")]
)


(define_insn "*baddu_si_eb"
[(set (match_operand:SI 0 "register_operand" "=d") (zero_extend:SI (subreg:QI (plus:SI (match_operand:SI 1 "register_operand" "d") (match_operand:SI 2 "register_operand" "d") ) 3) ) ) ]
  "ISA_HAS_BADDU && BYTES_BIG_ENDIAN"
  "baddu\\t%0,%1,%2"
  [(set_attr "alu_type" "add")]
)

(define_insn "*baddu_si_el"
[(set (match_operand:SI 0 "register_operand" "=d") (zero_extend:SI (subreg:QI (plus:SI (match_operand:SI 1 "register_operand" "d") (match_operand:SI 2 "register_operand" "d") ) 0) ) ) ]
  "ISA_HAS_BADDU && !BYTES_BIG_ENDIAN"
  "baddu\\t%0,%1,%2"
  [(set_attr "alu_type" "add")]
)

(define_insn "*baddu_di<mode>"
[(set (match_operand:GPR 0 "register_operand" "=d") (zero_extend:GPR (truncate:QI (plus:DI (match_operand:DI 1 "register_operand" "d") (match_operand:DI 2 "register_operand" "d") ) ) ) ) ]
  "ISA_HAS_BADDU && TARGET_64BIT"
  "baddu\\t%0,%1,%2"
  [(set_attr "alu_type" "add")]
)



(define_insn "sub<mode>3"
[(set (match_operand:ANYF 0 "register_operand" "=f") (minus:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) ) ]
  ""
  "sub.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "sub<mode>3"
[(set (match_operand:GPR 0 "register_operand" "=d") (minus:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "register_operand" "d") ) ) ]
  ""
  "<d>subu\t%0,%1,%2"
  [(set_attr "alu_type" "sub")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*subsi3_extended"
[(set (match_operand:DI 0 "register_operand" "=d") (sign_extend:DI (minus:SI (match_operand:SI 1 "register_operand" "d") (match_operand:SI 2 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT"
  "subu\t%0,%1,%2"
  [(set_attr "alu_type" "sub")
   (set_attr "mode" "DI")]
)



(define_expand "mul<mode>3"
[(set (match_operand:SCALARF 0 "register_operand" "") (mult:SCALARF (match_operand:SCALARF 1 "register_operand" "") (match_operand:SCALARF 2 "register_operand" "") ) ) ]
  ""
  ""
)

(define_insn "*mul<mode>3"
[(set (match_operand:SCALARF 0 "register_operand" "=f") (mult:SCALARF (match_operand:SCALARF 1 "register_operand" "f") (match_operand:SCALARF 2 "register_operand" "f") ) ) ]
  "!TARGET_4300_MUL_FIX"
  "mul.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fmul")
   (set_attr "mode" "<MODE>")]
)


(define_insn "*mul<mode>3_r4300"
[(set (match_operand:SCALARF 0 "register_operand" "=f") (mult:SCALARF (match_operand:SCALARF 1 "register_operand" "f") (match_operand:SCALARF 2 "register_operand" "f") ) ) ]
  "TARGET_4300_MUL_FIX"
  "mul.<fmt>\t%0,%1,%2\;nop"
  [(set_attr "type" "fmul")
   (set_attr "mode" "<MODE>")
   (set_attr "length" "8")]
)

(define_insn "mulv2sf3"
[(set (match_operand:V2SF 0 "register_operand" "=f") (mult:V2SF (match_operand:V2SF 1 "register_operand" "f") (match_operand:V2SF 2 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT"
  "mul.ps\t%0,%1,%2"
  [(set_attr "type" "fmul")
   (set_attr "mode" "SF")]
)


(define_expand "mul<mode>3"
[(set (match_operand:GPR 0 "register_operand" "") (mult:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "register_operand" "") ) ) ]
  ""
{
  rtx lo;
  if (TARGET_LOONGSON_2EF || TARGET_LOONGSON_3A)
    emit_insn (gen_mul<mode>3_mul3_loongson (operands[0], operands[1],
                                             operands[2]));
  else if (ISA_HAS_<D>MUL3)
    emit_insn (gen_mul<mode>3_mul3 (operands[0], operands[1], operands[2]));
  else if (TARGET_MIPS16)
    {
      lo = gen_rtx_REG (<MODE>mode, LO_REGNUM);
      emit_insn (gen_mul<mode>3_internal (lo, operands[1], operands[2]));
      emit_move_insn (operands[0], lo);
    }
  else if (TARGET_FIX_R4000)
    emit_insn (gen_mul<mode>3_r4000 (operands[0], operands[1], operands[2]));
  else
    emit_insn
      (gen_mul<mode>3_internal (operands[0], operands[1], operands[2]));
  DONE;
}
)

(define_insn "mul<mode>3_mul3_loongson"
[(set (match_operand:GPR 0 "register_operand" "=d") (mult:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "register_operand" "d") ) ) ]
  "TARGET_LOONGSON_2EF || TARGET_LOONGSON_3A"
{
  if (TARGET_LOONGSON_2EF)
    return "<d>multu.g\t%0,%1,%2";
  else
    return "gs<d>multu\t%0,%1,%2";
}
  [(set_attr "type" "imul3nc")
   (set_attr "mode" "<MODE>")]
)

(define_insn "mul<mode>3_mul3"
[ (set (match_operand:GPR 0 "register_operand" "=d,l") (mult:GPR (match_operand:GPR 1 "register_operand" "d,d") (match_operand:GPR 2 "register_operand" "d,d") ) ) (clobber (match_scratch:GPR 3 "=l,X") ) ]
  "ISA_HAS_<D>MUL3"
{
  if (which_alternative == 1)
    return "<d>mult\t%1,%2";
  if (<MODE>mode == SImode && TARGET_MIPS3900)
    return "mult\t%0,%1,%2";
  return "<d>mul\t%0,%1,%2";
}
  [(set_attr "type" "imul3,imul")
   (set_attr "mode" "<MODE>")]
)



(define_peephole2
  [(parallel
       [(set (match_operand:SI 0 "lo_operand")
	     (mult:SI (match_operand:SI 1 "d_operand")
		      (match_operand:SI 2 "d_operand")))
        (clobber (scratch:SI))])
   (set (match_operand:SI 3 "d_operand")
	(match_dup 0))]
  "ISA_HAS_MUL3 && peep2_reg_dead_p (2, operands[0])"
  [(parallel
       [(set (match_dup 3)
	     (mult:SI (match_dup 1)
		      (match_dup 2)))
        (clobber (match_dup 0))])])
(define_insn "mul<mode>3_internal"
[(set (match_operand:GPR 0 "muldiv_target_operand" "=l") (mult:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "register_operand" "d") ) ) ]
  "!TARGET_FIX_R4000"
  "<d>mult\t%1,%2"
  [(set_attr "type" "imul")
   (set_attr "mode" "<MODE>")]
)

(define_insn "mul<mode>3_r4000"
[ (set (match_operand:GPR 0 "register_operand" "=d") (mult:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "register_operand" "d") ) ) (clobber (match_scratch:GPR 3 "=l") ) ]
  "TARGET_FIX_R4000"
  "<d>mult\t%1,%2\;mflo\t%0"
  [(set_attr "type" "imul")
   (set_attr "mode" "<MODE>")
   (set_attr "length" "8")]
)


(define_peephole2 
[ (set (match_operand:SI 0 "lo_operand" "") (mult:SI (match_operand:SI 1 "d_operand" "") (match_operand:SI 2 "d_operand" "") ) ) (set (match_operand:SI 3 "d_operand" "") (match_dup 0) ) ]
  "ISA_HAS_MACC && !ISA_HAS_MUL3"
[  (set (match_dup 0) (const_int 0) ) (parallel [(set (match_dup 0) (plus:SI (mult:SI (match_dup 1) (match_dup 2) ) (match_dup 0) ) ) (set (match_dup 3) (plus:SI (mult:SI (match_dup 1) (match_dup 2) ) (match_dup 0) ) ) ]) ]
)


(define_insn "*mul_acc_si"
[ (set (match_operand:SI 0 "register_operand" "=l*?*?,d?") (plus:SI (mult:SI (match_operand:SI 1 "register_operand" "d,d") (match_operand:SI 2 "register_operand" "d,d") ) (match_operand:SI 3 "register_operand" "0,d") ) ) (clobber (match_scratch:SI 4 "=X,l") ) (clobber (match_scratch:SI 5 "=X,&d") ) ]
  "GENERATE_MADD_MSUB && !TARGET_MIPS16"
  "@
    madd\t%1,%2
    #"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")
   (set_attr "length"	"4,8")]
)


(define_insn "*mul_acc_si_r3900"
[ (set (match_operand:SI 0 "register_operand" "=l*?*?,d*?,d?") (plus:SI (mult:SI (match_operand:SI 1 "register_operand" "d,d,d") (match_operand:SI 2 "register_operand" "d,d,d") ) (match_operand:SI 3 "register_operand" "0,l,d") ) ) (clobber (match_scratch:SI 4 "=X,3,l") ) (clobber (match_scratch:SI 5 "=X,X,&d") ) ]
  "TARGET_MIPS3900 && !TARGET_MIPS16"
  "@
    madd\t%1,%2
    madd\t%0,%1,%2
    #"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")
   (set_attr "length"	"4,4,8")]
)


(define_split 
[ (set (match_operand:SI 0 "d_operand" "") (plus:SI (mult:SI (match_operand:SI 1 "d_operand" "") (match_operand:SI 2 "d_operand" "") ) (match_operand:SI 3 "d_operand" "") ) ) (clobber (match_operand:SI 4 "lo_operand" "") ) (clobber (match_operand:SI 5 "d_operand" "") ) ]
  "reload_completed"
[  (parallel [(set (match_dup 5) (mult:SI (match_dup 1) (match_dup 2) ) ) (clobber (match_dup 4) ) ]) (set (match_dup 0) (plus:SI (match_dup 5) (match_dup 3) ) ) ]
  ""
)

(define_insn "*macc"
[ (set (match_operand:SI 0 "register_operand" "=l,d") (plus:SI (mult:SI (match_operand:SI 1 "register_operand" "d,d") (match_operand:SI 2 "register_operand" "d,d") ) (match_operand:SI 3 "register_operand" "0,l") ) ) (clobber (match_scratch:SI 4 "=X,3") ) ]
  "ISA_HAS_MACC"
{
  if (which_alternative == 1)
    return "macc\t%0,%1,%2";
  else if (TARGET_MIPS5500)
    return "madd\t%1,%2";
  else
    /* The VR4130 assumes that there is a two-cycle latency between a macc
       that "writes" to $0 and an instruction that reads from it.  We avoid
       this by assigning to $1 instead.  */
    return "%[macc\t%@,%1,%2%]";
}
  [(set_attr "type" "imadd")
   (set_attr "mode" "SI")]
)

(define_insn "*msac"
[ (set (match_operand:SI 0 "register_operand" "=l,d") (minus:SI (match_operand:SI 1 "register_operand" "0,l") (mult:SI (match_operand:SI 2 "register_operand" "d,d") (match_operand:SI 3 "register_operand" "d,d") ) ) ) (clobber (match_scratch:SI 4 "=X,1") ) ]
  "ISA_HAS_MSAC"
{
  if (which_alternative == 1)
    return "msac\t%0,%2,%3";
  else if (TARGET_MIPS5500)
    return "msub\t%2,%3";
  else
    return "msac\t$0,%2,%3";
}
  [(set_attr "type"     "imadd")
   (set_attr "mode"     "SI")]
)


(define_insn_and_split "*msac_using_macc"
[ (set (match_operand:SI 0 "register_operand" "=l,d") (minus:SI (match_operand:SI 1 "register_operand" "0,l") (mult:SI (match_operand:SI 2 "register_operand" "d,d") (match_operand:SI 3 "register_operand" "d,d") ) ) ) (clobber (match_scratch:SI 4 "=X,1") ) (clobber (match_scratch:SI 5 "=d,d") ) ]
  "ISA_HAS_MACC && !ISA_HAS_MSAC"
  "#"
  "&& reload_completed"
[  (set (match_dup 5) (neg:SI (match_dup 3) ) ) (parallel [(set (match_dup 0) (plus:SI (mult:SI (match_dup 2) (match_dup 5) ) (match_dup 1) ) ) (clobber (match_dup 4) ) ]) ]
  ""
  [(set_attr "type"     "imadd")
   (set_attr "length"	"8")]
)


(define_insn "*macc2"
[ (set (match_operand:SI 0 "muldiv_target_operand" "=l") (plus:SI (mult:SI (match_operand:SI 1 "register_operand" "d") (match_operand:SI 2 "register_operand" "d") ) (match_dup 0) ) ) (set (match_operand:SI 3 "register_operand" "=d") (plus:SI (mult:SI (match_dup 1) (match_dup 2) ) (match_dup 0) ) ) ]
  "ISA_HAS_MACC && reload_completed"
  "macc\t%3,%1,%2"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
)

(define_insn "*msac2"
[ (set (match_operand:SI 0 "muldiv_target_operand" "=l") (minus:SI (match_dup 0) (mult:SI (match_operand:SI 1 "register_operand" "d") (match_operand:SI 2 "register_operand" "d") ) ) ) (set (match_operand:SI 3 "register_operand" "=d") (minus:SI (match_dup 0) (mult:SI (match_dup 1) (match_dup 2) ) ) ) ]
  "ISA_HAS_MSAC && reload_completed"
  "msac\t%3,%1,%2"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
)



(define_peephole2
  [(parallel
       [(set (match_operand:SI 0 "lo_operand")
	     (match_operand:SI 1 "macc_msac_operand"))
	(clobber (scratch:SI))])
   (set (match_operand:SI 2 "d_operand")
	(match_dup 0))]
  ""
  [(parallel [(set (match_dup 0)
		   (match_dup 1))
	      (set (match_dup 2)
		   (match_dup 1))])])
(define_peephole2
  [(match_scratch:SI 0 "d")
   (set (match_operand:SI 1 "lo_operand")
	(match_operand:SI 2 "d_operand"))
   (match_dup 0)
   (parallel
       [(set (match_operand:SI 3 "d_operand")
	     (match_operand:SI 4 "macc_msac_operand"))
	(clobber (match_dup 1))])]
  "ISA_HAS_MUL3 && peep2_reg_dead_p (2, operands[1])"
  [(parallel [(set (match_dup 0)
		   (match_dup 5))
	      (clobber (match_dup 1))])
   (set (match_dup 3)
	(match_dup 6))]
{
  operands[5] = XEXP (operands[4], GET_CODE (operands[4]) == PLUS ? 0 : 1);
  operands[6] = gen_rtx_fmt_ee (GET_CODE (operands[4]), SImode,
				operands[2], operands[0]);
})
(define_peephole2
  [(match_scratch:SI 0 "d")
   (set (match_operand:SI 1 "lo_operand")
	(match_operand:SI 2 "d_operand"))
   (match_dup 0)
   (parallel
       [(set (match_dup 1)
	     (match_operand:SI 3 "macc_msac_operand"))
	(clobber (scratch:SI))])
   (match_dup 0)
   (set (match_operand:SI 4 "d_operand")
	(match_dup 1))]
  "ISA_HAS_MUL3 && peep2_reg_dead_p (3, operands[1])"
  [(parallel [(set (match_dup 0)
		   (match_dup 5))
	      (clobber (match_dup 1))])
   (set (match_dup 4)
	(match_dup 6))]
{
  operands[5] = XEXP (operands[3], GET_CODE (operands[3]) == PLUS ? 0 : 1);
  operands[6] = gen_rtx_fmt_ee (GET_CODE (operands[3]), SImode,
				operands[2], operands[0]);
})
(define_insn "*mul_sub_si"
[ (set (match_operand:SI 0 "register_operand" "=l*?*?,d?") (minus:SI (match_operand:SI 1 "register_operand" "0,d") (mult:SI (match_operand:SI 2 "register_operand" "d,d") (match_operand:SI 3 "register_operand" "d,d") ) ) ) (clobber (match_scratch:SI 4 "=X,l") ) (clobber (match_scratch:SI 5 "=X,&d") ) ]
  "GENERATE_MADD_MSUB"
  "@
   msub\t%2,%3
   #"
  [(set_attr "type"     "imadd")
   (set_attr "mode"     "SI")
   (set_attr "length"   "4,8")]
)


(define_split 
[ (set (match_operand:SI 0 "d_operand" "") (minus:SI (match_operand:SI 1 "d_operand" "") (mult:SI (match_operand:SI 2 "d_operand" "") (match_operand:SI 3 "d_operand" "") ) ) ) (clobber (match_operand:SI 4 "lo_operand" "") ) (clobber (match_operand:SI 5 "d_operand" "") ) ]
  "reload_completed"
[  (parallel [(set (match_dup 5) (mult:SI (match_dup 2) (match_dup 3) ) ) (clobber (match_dup 4) ) ]) (set (match_dup 0) (minus:SI (match_dup 1) (match_dup 5) ) ) ]
	""
)

(define_insn "*muls"
[ (set (match_operand:SI 0 "register_operand" "=l,d") (neg:SI (mult:SI (match_operand:SI 1 "register_operand" "d,d") (match_operand:SI 2 "register_operand" "d,d") ) ) ) (clobber (match_scratch:SI 3 "=X,l") ) ]
  "ISA_HAS_MULS"
  "@
   muls\t$0,%1,%2
   muls\t%0,%1,%2"
  [(set_attr "type"     "imul,imul3")
   (set_attr "mode"     "SI")]
)

(define_expand "<u>mulsidi3"
[(set (match_operand:DI 0 "register_operand" "") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "") ) (any_extend:DI (match_operand:SI 2 "register_operand" "") ) ) ) ]
  "mips_mulsidi3_gen_fn (<CODE>) != NULL"
{
  mulsidi3_gen_fn fn = mips_mulsidi3_gen_fn (<CODE>);
  emit_insn (fn (operands[0], operands[1], operands[2]));
  DONE;
}
)

(define_expand "<u>mulsidi3_32bit_mips16"
[(set (match_operand:DI 0 "register_operand" "") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "") ) (any_extend:DI (match_operand:SI 2 "register_operand" "") ) ) ) ]
  "!TARGET_64BIT && TARGET_MIPS16"
{
  rtx hilo;
  hilo = gen_rtx_REG (DImode, MD_REG_FIRST);
  emit_insn (gen_<u>mulsidi3_32bit (hilo, operands[1], operands[2]));
  emit_move_insn (operands[0], hilo);
  DONE;
}
)


(define_insn "<u>mulsidi3_32bit"
[(set (match_operand:DI 0 "muldiv_target_operand" "=ka") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ) ]
  "!TARGET_64BIT && (!TARGET_FIX_R4000 || ISA_HAS_DSP)"
{
  if (ISA_HAS_DSP_MULT)
    return "mult<u>\t%q0,%1,%2";
  else
    return "mult<u>\t%1,%2";
}
  [(set_attr "type" "imul")
   (set_attr "mode" "SI")]
)

(define_insn "<u>mulsidi3_32bit_r4000"
[ (set (match_operand:DI 0 "register_operand" "=d") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ) (clobber (match_scratch:DI 3 "=x") ) ]
  "!TARGET_64BIT && TARGET_FIX_R4000 && !ISA_HAS_DSP"
  "mult<u>\t%1,%2\;mflo\t%L0\;mfhi\t%M0"
  [(set_attr "type" "imul")
   (set_attr "mode" "SI")
   (set_attr "length" "12")]
)

(define_insn_and_split "<u>mulsidi3_64bit"
[ (set (match_operand:DI 0 "register_operand" "=d") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ) (clobber (match_scratch:TI 3 "=x") ) (clobber (match_scratch:DI 4 "=d") ) ]
  "TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3 && !TARGET_MIPS16"
  "#"
  "&& reload_completed"
[  (const_int 0) ]
{
  emit_insn (gen_<u>mulsidi3_64bit_split (operands[0], operands[1],
					  operands[2], operands[4]));
  DONE;
}
  [(set_attr "type" "imul")
   (set_attr "mode" "SI")
   (set (attr "length")
	(if_then_else (match_test "ISA_HAS_EXT_INS")
		      (const_int 16)
		      (const_int 28)))]
)

(define_expand "<u>mulsidi3_64bit_mips16"
[(set (match_operand:DI 0 "register_operand" "") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "") ) (any_extend:DI (match_operand:SI 2 "register_operand" "") ) ) ) ]
  "TARGET_64BIT && TARGET_MIPS16"
{
  emit_insn (gen_<u>mulsidi3_64bit_split (operands[0], operands[1],
					  operands[2], gen_reg_rtx (DImode)));
  DONE;
}
)

(define_expand "<u>mulsidi3_64bit_split"
[ (set (match_operand:DI 0 "register_operand" "") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "") ) (any_extend:DI (match_operand:SI 2 "register_operand" "") ) ) ) (clobber (match_operand:DI 3 "register_operand" "") ) ]
  ""
{
  rtx hilo;
  hilo = gen_rtx_REG (TImode, MD_REG_FIRST);
  emit_insn (gen_<u>mulsidi3_64bit_hilo (hilo, operands[1], operands[2]));
  emit_move_insn (operands[0], gen_rtx_REG (DImode, LO_REGNUM));
  emit_insn (gen_mfhidi_ti (operands[3], hilo));
  if (ISA_HAS_EXT_INS)
    emit_insn (gen_insvdi (operands[0], GEN_INT (32), GEN_INT (32),
			   operands[3]));
  else
    {
      /* Zero-extend the low part.  */
      mips_emit_binary (ASHIFT, operands[0], operands[0], GEN_INT (32));
      mips_emit_binary (LSHIFTRT, operands[0], operands[0], GEN_INT (32));
      /* Shift the high part into place.  */
      mips_emit_binary (ASHIFT, operands[3], operands[3], GEN_INT (32));
      /* OR the two halves together.  */
      mips_emit_binary (IOR, operands[0], operands[0], operands[3]);
    }
  DONE;
}
)

(define_insn "<u>mulsidi3_64bit_hilo"
[(set (match_operand:TI 0 "muldiv_target_operand" "=x") (unspec:TI [(mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ] UNSPEC_SET_HILO) ) ]
  "TARGET_64BIT && !TARGET_FIX_R4000"
  "mult<u>\t%1,%2"
  [(set_attr "type" "imul")
   (set_attr "mode" "SI")]
)


(define_insn "mulsidi3_64bit_dmul"
[ (set (match_operand:DI 0 "register_operand" "=d") (mult:DI (sign_extend:DI (match_operand:SI 1 "register_operand" "d") ) (sign_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ) (clobber (match_scratch:DI 3 "=l") ) ]
  "TARGET_64BIT && ISA_HAS_DMUL3"
  "dmul\t%0,%1,%2"
  [(set_attr "type" "imul3")
   (set_attr "mode" "DI")]
)


(define_insn "*muls<u>_di"
[(set (match_operand:DI 0 "muldiv_target_operand" "=x") (neg:DI (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ) ) ]
  "!TARGET_64BIT && ISA_HAS_MULS"
  "muls<u>\t$0,%1,%2"
  [(set_attr "type" "imul")
   (set_attr "mode" "SI")]
)


(define_insn "<u>msubsidi4"
[(set (match_operand:DI 0 "muldiv_target_operand" "=ka") (minus:DI (match_operand:DI 3 "muldiv_target_operand" "0") (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ) ) ]
  "!TARGET_64BIT && (ISA_HAS_MSAC || GENERATE_MADD_MSUB || ISA_HAS_DSP)"
{
  if (ISA_HAS_DSP_MULT)
    return "msub<u>\t%q0,%1,%2";
  else if (TARGET_MIPS5500 || GENERATE_MADD_MSUB)
    return "msub<u>\t%1,%2";
  else
    return "msac<u>\t$0,%1,%2";
}
  [(set_attr "type" "imadd")
   (set_attr "mode" "SI")]
)


(define_expand "<su>mulsi3_highpart"
[(set (match_operand:SI 0 "register_operand" "") (truncate:SI (lshiftrt:DI (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "") ) (any_extend:DI (match_operand:SI 2 "register_operand" "") ) ) (const_int 32) ) ) ) ]
  ""
{
  if (ISA_HAS_MULHI)
    emit_insn (gen_<su>mulsi3_highpart_mulhi_internal (operands[0],
						       operands[1],
						       operands[2]));
  else if (TARGET_MIPS16)
    emit_insn (gen_<su>mulsi3_highpart_split (operands[0], operands[1],
					      operands[2]));
  else
    emit_insn (gen_<su>mulsi3_highpart_internal (operands[0], operands[1],
					         operands[2]));
  DONE;
}
)

(define_insn_and_split "<su>mulsi3_highpart_internal"
[ (set (match_operand:SI 0 "register_operand" "=d") (truncate:SI (lshiftrt:DI (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) (const_int 32) ) ) ) (clobber (match_scratch:SI 3 "=l") ) ]
  "!ISA_HAS_MULHI && !TARGET_MIPS16"
  { return TARGET_FIX_R4000 ? "mult<u>\t%1,%2\n\tmfhi\t%0" : "#"; }
  "&& reload_completed && !TARGET_FIX_R4000"
[  (const_int 0) ]
{
  emit_insn (gen_<su>mulsi3_highpart_split (operands[0], operands[1],
					    operands[2]));
  DONE;
}
  [(set_attr "type" "imul")
   (set_attr "mode" "SI")
   (set_attr "length" "8")]
)

(define_expand "<su>mulsi3_highpart_split"
[(set (match_operand:SI 0 "register_operand" "") (truncate:SI (lshiftrt:DI (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "") ) (any_extend:DI (match_operand:SI 2 "register_operand" "") ) ) (const_int 32) ) ) ) ]
  ""
{
  rtx hilo;
  if (TARGET_64BIT)
    {
      hilo = gen_rtx_REG (TImode, MD_REG_FIRST);
      emit_insn (gen_<u>mulsidi3_64bit_hilo (hilo, operands[1], operands[2]));
      emit_insn (gen_mfhisi_ti (operands[0], hilo));
    }
  else
    {
      hilo = gen_rtx_REG (DImode, MD_REG_FIRST);
      emit_insn (gen_<u>mulsidi3_32bit (hilo, operands[1], operands[2]));
      emit_insn (gen_mfhisi_di (operands[0], hilo));
    }
  DONE;
}
)

(define_insn "<su>mulsi3_highpart_mulhi_internal"
[ (set (match_operand:SI 0 "register_operand" "=d") (truncate:SI (lshiftrt:DI (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) (const_int 32) ) ) ) (clobber (match_scratch:SI 3 "=l") ) ]
  "ISA_HAS_MULHI"
  "mulhi<u>\t%0,%1,%2"
  [(set_attr "type" "imul3")
   (set_attr "mode" "SI")]
)

(define_insn "*<su>mulsi3_highpart_neg_mulhi_internal"
[ (set (match_operand:SI 0 "register_operand" "=d") (truncate:SI (lshiftrt:DI (neg:DI (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) ) (const_int 32) ) ) ) (clobber (match_scratch:SI 3 "=l") ) ]
  "ISA_HAS_MULHI"
  "mulshi<u>\t%0,%1,%2"
  [(set_attr "type" "imul3")
   (set_attr "mode" "SI")]
)


(define_expand "<su>muldi3_highpart"
[(set (match_operand:DI 0 "register_operand" "") (truncate:DI (lshiftrt:TI (mult:TI (any_extend:TI (match_operand:DI 1 "register_operand" "") ) (any_extend:TI (match_operand:DI 2 "register_operand" "") ) ) (const_int 64) ) ) ) ]
  "TARGET_64BIT && !(<CODE> == ZERO_EXTEND && TARGET_FIX_VR4120)"
{
  if (TARGET_MIPS16)
    emit_insn (gen_<su>muldi3_highpart_split (operands[0], operands[1],
					      operands[2]));
  else
    emit_insn (gen_<su>muldi3_highpart_internal (operands[0], operands[1],
						 operands[2]));
  DONE;
}
)

(define_insn_and_split "<su>muldi3_highpart_internal"
[ (set (match_operand:DI 0 "register_operand" "=d") (truncate:DI (lshiftrt:TI (mult:TI (any_extend:TI (match_operand:DI 1 "register_operand" "d") ) (any_extend:TI (match_operand:DI 2 "register_operand" "d") ) ) (const_int 64) ) ) ) (clobber (match_scratch:DI 3 "=l") ) ]
  "TARGET_64BIT
   && !TARGET_MIPS16
   && !(<CODE> == ZERO_EXTEND && TARGET_FIX_VR4120)"
  { return TARGET_FIX_R4000 ? "dmult<u>\t%1,%2\n\tmfhi\t%0" : "#"; }
  "&& reload_completed && !TARGET_FIX_R4000"
[  (const_int 0) ]
{
  emit_insn (gen_<su>muldi3_highpart_split (operands[0], operands[1],
					    operands[2]));
  DONE;
}
  [(set_attr "type" "imul")
   (set_attr "mode" "DI")
   (set_attr "length" "8")]
)

(define_expand "<su>muldi3_highpart_split"
[(set (match_operand:DI 0 "register_operand" "") (truncate:DI (lshiftrt:TI (mult:TI (any_extend:TI (match_operand:DI 1 "register_operand" "") ) (any_extend:TI (match_operand:DI 2 "register_operand" "") ) ) (const_int 64) ) ) ) ]
  ""
{
  rtx hilo;
  hilo = gen_rtx_REG (TImode, MD_REG_FIRST);
  emit_insn (gen_<u>mulditi3_internal (hilo, operands[1], operands[2]));
  emit_insn (gen_mfhidi_ti (operands[0], hilo));
  DONE;
}
)

(define_expand "<u>mulditi3"
[(set (match_operand:TI 0 "register_operand" "") (mult:TI (any_extend:TI (match_operand:DI 1 "register_operand" "") ) (any_extend:TI (match_operand:DI 2 "register_operand" "") ) ) ) ]
  "TARGET_64BIT && !(<CODE> == ZERO_EXTEND && TARGET_FIX_VR4120)"
{
  rtx hilo;
  if (TARGET_MIPS16)
    {
      hilo = gen_rtx_REG (TImode, MD_REG_FIRST);
      emit_insn (gen_<u>mulditi3_internal (hilo, operands[1], operands[2]));
      emit_move_insn (operands[0], hilo);
    }
  else if (TARGET_FIX_R4000)
    emit_insn (gen_<u>mulditi3_r4000 (operands[0], operands[1], operands[2]));
  else
    emit_insn (gen_<u>mulditi3_internal (operands[0], operands[1],
					 operands[2]));
  DONE;
}
)

(define_insn "<u>mulditi3_internal"
[(set (match_operand:TI 0 "muldiv_target_operand" "=x") (mult:TI (any_extend:TI (match_operand:DI 1 "register_operand" "d") ) (any_extend:TI (match_operand:DI 2 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT
   && !TARGET_FIX_R4000
   && !(<CODE> == ZERO_EXTEND && TARGET_FIX_VR4120)"
  "dmult<u>\t%1,%2"
  [(set_attr "type" "imul")
   (set_attr "mode" "DI")]
)

(define_insn "<u>mulditi3_r4000"
[ (set (match_operand:TI 0 "register_operand" "=d") (mult:TI (any_extend:TI (match_operand:DI 1 "register_operand" "d") ) (any_extend:TI (match_operand:DI 2 "register_operand" "d") ) ) ) (clobber (match_scratch:TI 3 "=x") ) ]
  "TARGET_64BIT
   && TARGET_FIX_R4000
   && !(<CODE> == ZERO_EXTEND && TARGET_FIX_VR4120)"
  "dmult<u>\t%1,%2\;mflo\t%L0\;mfhi\t%M0"
  [(set_attr "type" "imul")
   (set_attr "mode" "DI")
   (set_attr "length" "12")]
)


(define_insn "madsi"
[(set (match_operand:SI 0 "register_operand" "+l") (plus:SI (mult:SI (match_operand:SI 1 "register_operand" "d") (match_operand:SI 2 "register_operand" "d") ) (match_dup 0) ) ) ]
  "TARGET_MAD"
  "mad\t%1,%2"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
)


(define_insn "<u>maddsidi4"
[(set (match_operand:DI 0 "muldiv_target_operand" "=ka") (plus:DI (mult:DI (any_extend:DI (match_operand:SI 1 "register_operand" "d") ) (any_extend:DI (match_operand:SI 2 "register_operand" "d") ) ) (match_operand:DI 3 "muldiv_target_operand" "0") ) ) ]
  "(TARGET_MAD || ISA_HAS_MACC || GENERATE_MADD_MSUB || ISA_HAS_DSP)
   && !TARGET_64BIT"
{
  if (TARGET_MAD)
    return "mad<u>\t%1,%2";
  else if (ISA_HAS_DSP_MULT)
    return "madd<u>\t%q0,%1,%2";
  else if (GENERATE_MADD_MSUB || TARGET_MIPS5500)
    return "madd<u>\t%1,%2";
  else
    /* See comment in *macc.  */
    return "%[macc<u>\t%@,%1,%2%]";
}
  [(set_attr "type" "imadd")
   (set_attr "mode" "SI")]
)


(define_insn "*madd4<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (plus:ANYF (mult:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "f") ) ) ]
  "ISA_HAS_FP_MADD4_MSUB4 && TARGET_FUSED_MADD"
  "madd.<fmt>\t%0,%3,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*madd3<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (plus:ANYF (mult:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "0") ) ) ]
  "ISA_HAS_FP_MADD3_MSUB3 && TARGET_FUSED_MADD"
  "madd.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*msub4<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (minus:ANYF (mult:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "f") ) ) ]
  "ISA_HAS_FP_MADD4_MSUB4 && TARGET_FUSED_MADD"
  "msub.<fmt>\t%0,%3,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*msub3<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (minus:ANYF (mult:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "0") ) ) ]
 "ISA_HAS_FP_MADD3_MSUB3 && TARGET_FUSED_MADD"
  "msub.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmadd4<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (neg:ANYF (plus:ANYF (mult:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "f") ) ) ) ]
  "ISA_HAS_NMADD4_NMSUB4 (<MODE>mode)
   && TARGET_FUSED_MADD
   && HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmadd.<fmt>\t%0,%3,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmadd3<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (neg:ANYF (plus:ANYF (mult:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "0") ) ) ) ]
  "ISA_HAS_NMADD3_NMSUB3 (<MODE>mode)
   && TARGET_FUSED_MADD
   && HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmadd.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmadd4<mode>_fastmath"
[(set (match_operand:ANYF 0 "register_operand" "=f") (minus:ANYF (mult:ANYF (neg:ANYF (match_operand:ANYF 1 "register_operand" "f") ) (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "f") ) ) ]
  "ISA_HAS_NMADD4_NMSUB4 (<MODE>mode)
   && TARGET_FUSED_MADD
   && !HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmadd.<fmt>\t%0,%3,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmadd3<mode>_fastmath"
[(set (match_operand:ANYF 0 "register_operand" "=f") (minus:ANYF (mult:ANYF (neg:ANYF (match_operand:ANYF 1 "register_operand" "f") ) (match_operand:ANYF 2 "register_operand" "f") ) (match_operand:ANYF 3 "register_operand" "0") ) ) ]
  "ISA_HAS_NMADD3_NMSUB3 (<MODE>mode)
   && TARGET_FUSED_MADD
   && !HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmadd.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmsub4<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (neg:ANYF (minus:ANYF (mult:ANYF (match_operand:ANYF 2 "register_operand" "f") (match_operand:ANYF 3 "register_operand" "f") ) (match_operand:ANYF 1 "register_operand" "f") ) ) ) ]
  "ISA_HAS_NMADD4_NMSUB4 (<MODE>mode)
   && TARGET_FUSED_MADD
   && HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmsub.<fmt>\t%0,%1,%2,%3"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmsub3<mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (neg:ANYF (minus:ANYF (mult:ANYF (match_operand:ANYF 2 "register_operand" "f") (match_operand:ANYF 3 "register_operand" "f") ) (match_operand:ANYF 1 "register_operand" "0") ) ) ) ]
  "ISA_HAS_NMADD3_NMSUB3 (<MODE>mode)
   && TARGET_FUSED_MADD
   && HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmsub.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmsub4<mode>_fastmath"
[(set (match_operand:ANYF 0 "register_operand" "=f") (minus:ANYF (match_operand:ANYF 1 "register_operand" "f") (mult:ANYF (match_operand:ANYF 2 "register_operand" "f") (match_operand:ANYF 3 "register_operand" "f") ) ) ) ]
  "ISA_HAS_NMADD4_NMSUB4 (<MODE>mode)
   && TARGET_FUSED_MADD
   && !HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmsub.<fmt>\t%0,%1,%2,%3"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "*nmsub3<mode>_fastmath"
[(set (match_operand:ANYF 0 "register_operand" "=f") (minus:ANYF (match_operand:ANYF 1 "register_operand" "f") (mult:ANYF (match_operand:ANYF 2 "register_operand" "f") (match_operand:ANYF 3 "register_operand" "0") ) ) ) ]
  "ISA_HAS_NMADD3_NMSUB3 (<MODE>mode)
   && TARGET_FUSED_MADD
   && !HONOR_SIGNED_ZEROS (<MODE>mode)
   && !HONOR_NANS (<MODE>mode)"
  "nmsub.<fmt>\t%0,%1,%2"
  [(set_attr "type" "fmadd")
   (set_attr "mode" "<UNITMODE>")]
)


(define_expand "div<mode>3"
[(set (match_operand:ANYF 0 "register_operand" "") (div:ANYF (match_operand:ANYF 1 "reg_or_1_operand" "") (match_operand:ANYF 2 "register_operand" "") ) ) ]
  "<divide_condition>"
{
  if (const_1_operand (operands[1], <MODE>mode))
    if (!(<recip_condition> && flag_unsafe_math_optimizations))
      operands[1] = force_reg (<MODE>mode, operands[1]);
}
)


(define_insn "*div<mode>3"
[(set (match_operand:ANYF 0 "register_operand" "=f") (div:ANYF (match_operand:ANYF 1 "register_operand" "f") (match_operand:ANYF 2 "register_operand" "f") ) ) ]
  "<divide_condition>"
{
  if (TARGET_FIX_SB1)
    return "div.<fmt>\t%0,%1,%2\;mov.<fmt>\t%0,%0";
  else
    return "div.<fmt>\t%0,%1,%2";
}
  [(set_attr "type" "fdiv")
   (set_attr "mode" "<UNITMODE>")
   (set (attr "length")
        (if_then_else (match_test "TARGET_FIX_SB1")
                      (const_int 8)
                      (const_int 4)))]
)

(define_insn "*recip<mode>3"
[(set (match_operand:ANYF 0 "register_operand" "") (div:ANYF (match_operand:ANYF 1 "const_1_operand" "") (match_operand:ANYF 2 "register_operand" "") ) ) ]
  "<recip_condition> && flag_unsafe_math_optimizations"
{
  if (TARGET_FIX_SB1)
    return "recip.<fmt>\t%0,%2\;mov.<fmt>\t%0,%0";
  else
    return "recip.<fmt>\t%0,%2";
}
  [(set_attr "type" "frdiv")
   (set_attr "mode" "<UNITMODE>")
   (set (attr "length")
        (if_then_else (match_test "TARGET_FIX_SB1")
                      (const_int 8)
                      (const_int 4)))]
)


(define_expand "divmod<mode>4"
[ (set (match_operand:GPR 0 "register_operand" "") (div:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "register_operand" "") ) ) (set (match_operand:GPR 3 "register_operand" "") (mod:GPR (match_dup 1) (match_dup 2) ) ) ]
  "!TARGET_FIX_VR4120"
{
  if (TARGET_MIPS16)
    {
      emit_insn (gen_divmod<mode>4_split (operands[3], operands[1],
					  operands[2]));
      emit_move_insn (operands[0], gen_rtx_REG (<MODE>mode, LO_REGNUM));
    }
  else
    emit_insn (gen_divmod<mode>4_internal (operands[0], operands[1],
					   operands[2], operands[3]));
  DONE;
}
)

(define_insn_and_split "divmode<mode>4_internal"
[ (set (match_operand:GPR 0 "muldiv_target_operand" "=l") (div:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "register_operand" "d") ) ) ]
  "!TARGET_FIX_VR4120 && !TARGET_MIPS16"
  "#"
  "&& reload_completed"
[  (const_int 0) ]
{
  emit_insn (gen_divmod<mode>4_split (operands[3], operands[1], operands[2]));
  DONE;
}
 [(set_attr "type" "idiv")
  (set_attr "mode" "<MODE>")
  (set_attr "length" "8")]
)

(define_expand "udivmode<mode>4"
[ (set (match_operand:GPR 0 "register_operand" "") (udiv:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "register_operand" "") ) ) (set (match_operand:GPR 3 "register_operand" "") (umod:GPR (match_dup 1) (match_dup 2) ) ) ] 
 ""
{
  if (TARGET_MIPS16)
    {
      emit_insn (gen_udivmod<mode>4_split (operands[3], operands[1],
					   operands[2]));
      emit_move_insn (operands[0], gen_rtx_REG (<MODE>mode, LO_REGNUM));
    }
  else
    emit_insn (gen_udivmod<mode>4_internal (operands[0], operands[1],
					    operands[2], operands[3]));
  DONE;
}
)

(define_insn_and_split "udivmode<mode>4_internal"
[ (set (match_operand:GPR 0 "muldiv_target_operand" "=l") (udiv:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "register_operand" "d") ) ) (set (match_operand:GPR 3 "register_operand" "=d") (umod:GPR (match_dup 1) (match_dup 2) ) ) ]
  "!TARGET_MIPS16"
  "#"
  "reload_completed"
[  (const_int 0) ]
{
  emit_insn (gen_udivmod<mode>4_split (operands[3], operands[1], operands[2]));
  DONE;
}
 [(set_attr "type" "idiv")
  (set_attr "mode" "<MODE>")
  (set_attr "length" "8")]
)

(define_expand "<u>divmod<mode>4_split"
[(set (match_operand:GPR 0 "register_operand" "") (any_mod:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "register_operand" "") ) ) ]
  ""
{
  rtx hilo;
  if (TARGET_64BIT)
    {
      hilo = gen_rtx_REG (TImode, MD_REG_FIRST);
      emit_insn (gen_<u>divmod<mode>4_hilo_ti (hilo, operands[1],
					       operands[2]));
      emit_insn (gen_mfhi<mode>_ti (operands[0], hilo));
    }
  else
    {
      hilo = gen_rtx_REG (DImode, MD_REG_FIRST);
      emit_insn (gen_<u>divmod<mode>4_hilo_di (hilo, operands[1],
					       operands[2]));
      emit_insn (gen_mfhi<mode>_di (operands[0], hilo));
    }
  DONE;
}
)

(define_insn "<u>divmod<GPR:mode>4_hilo_<HILO:mode>"
[(set (match_scratch: 0 "=x") (unspec:HILO [(any_div:GPR (match_operand:GPR 0 "register_operand" "d") (match_operand:GPR 1 "register_operand" "d") ) (UNSPEC_SET_HILO) ) ) ]
  ""
  { return mips_output_division ("<GPR:d>div<u>\t%.,%1,%2", operands); }
  [(set_attr "type" "idiv")
   (set_attr "mode" "<GPR:MODE>")]
)



(define_insn "sqrt<mode>2"
[(set (match_operand:ANYF 0 "register_operand" "=f") (sqrt:ANYF (match_operand:ANYF 1 "register_operand" "f") ) ) ]
  "<sqrt_condition>"
{
  if (TARGET_FIX_SB1)
    return "sqrt.<fmt>\t%0,%1\;mov.<fmt>\t%0,%0";
  else
    return "sqrt.<fmt>\t%0,%1";
}
  [(set_attr "type" "fsqrt")
   (set_attr "mode" "<UNITMODE>")
   (set (attr "length")
        (if_then_else (match_test "TARGET_FIX_SB1")
                      (const_int 8)
                      (const_int 4)))]
)

(define_insn "*rsqrt<mode>a"
[(set (match_operand:ANYF 0 "register_operand" "=f") (div:ANYF (match_operand:ANYF 1 "const_1_operand" "") (sqrt:ANYF (match_operand:ANYF 2 "register_operand" "f") ) ) ) ]
  "<recip_condition> && flag_unsafe_math_optimizations"
{
  if (TARGET_FIX_SB1)
    return "rsqrt.<fmt>\t%0,%2\;mov.<fmt>\t%0,%0";
  else
    return "rsqrt.<fmt>\t%0,%2";
}
  [(set_attr "type" "frsqrt")
   (set_attr "mode" "<UNITMODE>")
   (set (attr "length")
        (if_then_else (match_test "TARGET_FIX_SB1")
                      (const_int 8)
                      (const_int 4)))]
)

(define_insn "*rsqrt<mode>b"
[(set (match_operand:ANYF 0 "register_operand" "=f") (div:ANYF (match_operand:ANYF 1 "const_1_operand" "") (match_operand:ANYF 2 "register_operand" "f") ) ) ]
  "<recip_condition> && flag_unsafe_math_optimizations"
{
  if (TARGET_FIX_SB1)
    return "rsqrt.<fmt>\t%0,%2\;mov.<fmt>\t%0,%0";
  else
    return "rsqrt.<fmt>\t%0,%2";
}
  [(set_attr "type" "frsqrt")
   (set_attr "mode" "<UNITMODE>")
   (set (attr "length")
        (if_then_else (match_test "TARGET_FIX_SB1")
                      (const_int 8)
                      (const_int 4)))]
)



(define_insn "abs<mode>2"
[(set (match_operand:ANYF 0 "register_operand" "=f") (abs:ANYF (match_operand:ANYF 1 "register_operand" "f") ) ) ]
  "!HONOR_NANS (<MODE>mode)"
  "abs.<fmt>\t%0,%1"
  [(set_attr "type" "fabs")
   (set_attr "mode" "<UNITMODE>")]
)



(define_insn "clz<mode>2"
[(set (match_operand:GPR 0 "register_operand" "=d") (clz:GPR (match_operand:GPR 1 "register_operand" "d") ) ) ]
  "ISA_HAS_CLZ_CLO"
  "<d>clz\t%0,%1"
  [(set_attr "type" "clz")
   (set_attr "mode" "<MODE>")])
)


(define_insn "popcount<mode>2"
[(set (match_operand:GPR 0 "register_operand" "=d") (popcount:GPR (match_operand:GPR 1 "register_operand" "d") ) ) ]
  "ISA_HAS_POP"
  "<d>pop\t%0,%1"
  [(set_attr "type" "pop")
   (set_attr "mode" "<MODE>")]
)



(define_insn "negsi2"
[(set (match_operand:SI 0 "register_operand" "=d") (neg:SI (match_operand:SI 1 "register_operand" "d") ) ) ]
  ""
{
  if (TARGET_MIPS16)
    return "neg\t%0,%1";
  else
    return "subu\t%0,%.,%1";
}
  [(set_attr "alu_type"	"sub")
   (set_attr "mode"	"SI")]
)

(define_insn "negdi2"
[(set (match_operand:DI 0 "register_operand" "=d") (neg:DI (match_operand:DI 1 "register_operand" "d") ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16"
  "dsubu\t%0,%.,%1"
  [(set_attr "alu_type"	"sub")
   (set_attr "mode"	"DI")])
)


(define_insn "neg<mode>2"
[(set (match_operand:ANYF 0 "register_operand" "=f") (neg:ANYF (match_operand:ANYF 1 "register_operand" "f") ) ) ]
  "!HONOR_NANS (<MODE>mode)"
  "neg.<fmt>\t%0,%1"
  [(set_attr "type" "fneg")
   (set_attr "mode" "<UNITMODE>")]
)

(define_insn "one_cmpl<mode>2"
[(set (match_operand:GPR 0 "register_operand" "=d") (neg:GPR (match_operand:GPR 1 "register_operand" "d") ) ) ]
  ""
{
  if (TARGET_MIPS16)
    return "not\t%0,%1";
  else
    return "nor\t%0,%.,%1";
}
  [(set_attr "alu_type" "not")
   (set_attr "mode" "<MODE>")]
)



(define_insn "and<mode>3"
[(set (match_operand:GPR 0 "register_operand" "") (and:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "and_reg_operand" "") ) ) ]
)


(define_insn "*and<mode>3"
[(set (match_operand:GPR 0 "register_operand" "=d,d,d,d,d,d,d") (and:GPR (match_operand:GPR 1 "nonimmediate_operand" "o,o,W,d,d,d,d") (match_operand:and_operand 2 "and_reg_operand" "Yb,Yh,Yw,K,Yx,Yw,d") ) ) ]
  "!TARGET_MIPS16 && and_operands_ok (<MODE>mode, operands[1], operands[2])"
{
  int len;
  switch (which_alternative)
    {
    case 0:
      operands[1] = gen_lowpart (QImode, operands[1]);
      return "lbu\t%0,%1";
    case 1:
      operands[1] = gen_lowpart (HImode, operands[1]);
      return "lhu\t%0,%1";
    case 2:
      operands[1] = gen_lowpart (SImode, operands[1]);
      return "lwu\t%0,%1";
    case 3:
      return "andi\t%0,%1,%x2";
    case 4:
      len = low_bitmask_len (<MODE>mode, INTVAL (operands[2]));
      operands[2] = GEN_INT (len);
      return "<d>ext\t%0,%1,0,%2";
    case 5:
      return "#";
    case 6:
      return "and\t%0,%1,%2";
    default:
      gcc_unreachable ();
    }
}
  [(set_attr "move_type" "load,load,load,andi,ext_ins,shift_shift,logical")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*and<mode>3_mips16"
[(set (match_operand:GPR 0 "nonimmediate_operand" "=d,d,d,d,d") (and:GPR (match_operand:GPR 1 "register_operand" "%o,o,W,d,0") (match_operand:and_operand 2 "and_reg_operand" "Yb,Yh,Yw,Yw,d") ) ) ]
  "TARGET_MIPS16 && and_operands_ok (<MODE>mode, operands[1], operands[2])"
{
  switch (which_alternative)
    {
    case 0:
      operands[1] = gen_lowpart (QImode, operands[1]);
      return "lbu\t%0,%1";
    case 1:
      operands[1] = gen_lowpart (HImode, operands[1]);
      return "lhu\t%0,%1";
    case 2:
      operands[1] = gen_lowpart (SImode, operands[1]);
      return "lwu\t%0,%1";
    case 3:
      return "#";
    case 4:
      return "and\t%0,%2";
    default:
      gcc_unreachable ();
    }
}
  [(set_attr "move_type" "load,load,load,shift_shift,logical")
   (set_attr "mode" "<MODE>")])
)

(define_expand "ior<mode>3"
[(set (match_operand:GPR 0 "register_operand" "") (ior:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "uns_arith_operand" "") ) ) ]
  ""
{
  if (TARGET_MIPS16)
    operands[2] = force_reg (<MODE>mode, operands[2]);
}
)

(define_insn "*ior<mode>3"
[(set (match_operand:GPR 0 "register_operand" "=d,d") (ior:GPR (match_operand:GPR 1 "register_operand" "%d,d") (match_operand:GPR 2 "uns_arith_operand" "d,K") ) ) ]
  "!TARGET_MIPS16"
  "@
   or\t%0,%1,%2
   ori\t%0,%1,%x2"
  [(set_attr "alu_type" "or")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*ior<mode>3_mips16"
[(set (match_operand:GPR 0 "register_operand" "=d") (ior:GPR (match_operand:GPR 1 "register_operand" "%0") (match_operand:GPR 2 "register_operand" "d") ) ) ]
  "TARGET_MIPS16"
  "or\t%0,%2"
  [(set_attr "alu_type" "or")
   (set_attr "mode" "<MODE>")]
)

(define_expand "xor<mode>3"
[(set (match_operand:GPR 0 "register_operand" "") (xor:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "uns_arith_operand" "") ) ) ]
  ""
  ""
)


(define_insn ""
  [(set (match_operand:GPR 0 "register_operand" "=d,d")
	(xor:GPR (match_operand:GPR 1 "register_operand" "%d,d")
		 (match_operand:GPR 2 "uns_arith_operand" "d,K")))]
  "!TARGET_MIPS16"
  "@
   xor\t%0,%1,%2
   xori\t%0,%1,%x2"
  [(set_attr "alu_type" "xor")
   (set_attr "mode" "<MODE>")])
(define_insn ""
  [(set (match_operand:GPR 0 "register_operand" "=d,t,t")
	(xor:GPR (match_operand:GPR 1 "register_operand" "%0,d,d")
		 (match_operand:GPR 2 "uns_arith_operand" "d,K,d")))]
  "TARGET_MIPS16"
  "@
   xor\t%0,%2
   cmpi\t%1,%2
   cmp\t%1,%2"
  [(set_attr "alu_type" "xor")
   (set_attr "mode" "<MODE>")
   (set_attr_alternative "length"
		[(const_int 4)
		 (if_then_else (match_operand:VOID 2 "m16_uimm8_1")
			       (const_int 4)
			       (const_int 8))
		 (const_int 4)])])
(define_insn "*nor<mode>3"
[(set (match_operand:GPR 0 "register_operand" "=d") (and:GPR (not:GPR (match_operand:GPR 1 "register_operand" "d") ) (not:GPR (match_operand:GPR 2 "register_operand" "d") ) ) ) ]
  "!TARGET_MIPS16"
  "nor\t%0,%1,%2"
  [(set_attr "alu_type" "nor")
   (set_attr "mode" "<MODE>")]
)



(define_insn "truncdfsf2"
[(set (match_operand:SF 0 "register_oeprand" "=f") (float_truncate:SF (match_operand:DF 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT"
  "cvt.s.d\t%0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "cnv_mode"	"D2S")   
   (set_attr "mode"	"SF")]
)


(define_insn "truncdi<mode>2"
[(set (match_operand:SUBDI 0 "nonimmediate_operand" "=d,m") (truncate:SUBDI (match_operand:DI 1 "register_operand" "d,d") ) ) ]
  "TARGET_64BIT"
  "@
    sll\t%0,%1,0
    <store>\t%1,%0"
  [(set_attr "move_type" "sll0,store")
   (set_attr "mode" "SI")]
)


(define_insn "*ashr_trunc<mode>"
[(set (match_operand:SUBDI 0 "register_operand" "=d") (truncate:SUBDI (ashiftrt:DI (match_operand:DI 1 "register_operand" "d") (match_operand:DI 2 "const_arith_operand" "") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16 && IN_RANGE (INTVAL (operands[2]), 32, 63)"
  "dsra\t%0,%1,%2"
  [(set_attr "type" "shift")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*lshr32_trunc<mode>"
[(set (match_operand:SUBDI 0 "register_operand" "=d") (truncate:SUBDI (lshiftrt:DI (match_operand:DI 1 "register_operand" "d") (const_int 32) ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16"
  "dsra\t%0,%1,32"
  [(set_attr "type" "shift")
   (set_attr "mode" "<MODE>")]
)


(define_insn "*<optab>_trunc<mode>_exts"
[(set (match_operand:SUBDI 0 "register_operand" "=d") (truncate:SUBDI (any_shiftrt:DI (match_operand:DI 1 "register_operand" "d") (match_operand:DI 2 "const_arith_operand" "d") ) ) ) ]
  "ISA_HAS_EXTS && TARGET_64BIT && UINTVAL (operands[2]) < 32"
  "exts\t%0,%1,%2,31"
  [(set_attr "type" "arith")
   (set_attr "mode" "<MODE>")]
)



(define_expand "zero_extendsidi2"
[(set (match_operand:DI 0 "register_operand" "") (zero_extend:DI (match_operand:SI 1 "nonimmediate_operand" "") ) ) ]
  "TARGET_64BIT"
)

(define_insn_and_split "*zero_extendsidi2"
[(set (match_operand:DI 0 "register_operand" "=d,d") (zero_extend:DI (match_operand:SI 1 "nonimmediate_operand" "d,W") ) ) ]
  "TARGET_64BIT && !ISA_HAS_EXT_INS"
  "@
   #
   lwu\t%0,%1"
  "&& reload_completed && REG_P (operands[1])"
[  (set (match_dup 0) (ashift:DI (match_dup 1) (const_int 32) ) ) (set (match_dup 0) (lshiftrt:DI (match_dup 0) (const_int 32) ) ) ]
  { operands[1] = gen_lowpart (DImode, operands[1]); }
  [(set_attr "move_type" "shift_shift,load")
   (set_attr "mode" "DI")]
)

(define_insn "*zero_extendsidi2_dext"
[(set (match_operand:DI 0 "register_operand" "=d,d") (zero_extend:DI (match_operand:SI 1 "nonimmediate_operand" "d,W") ) ) ]
  "TARGET_64BIT && ISA_HAS_EXT_INS"
  "@
   dext\t%0,%1,0,32
   lwu\t%0,%1"
  [(set_attr "move_type" "arith,load")
   (set_attr "mode" "DI")]
)


(define_split 
[(set (match_operand:DI 0 "register_operand" "") (and:DI (match_operand:DI 1 "register_operand" "") (const_int 2147483647) ) ) ]
  "TARGET_64BIT && !ISA_HAS_EXT_INS && reload_completed"
[  (set (match_dup 0) (ashift:DI (match_dup 1) (const_int 32) ) ) (set (match_dup 0) (lshiftrt:DI (match_dup 0) (const_int 32) ) ) ]
)

(define_expand "zero_extend<SHORT:mode><GPR:mode>2"
[(set (match_operand:GPR 0 "register_operand" "") (zero_extend:DI (match_operand:SHORT 1 "nonimmediate_operand" "") ) ) ]
  ""
{
  if (TARGET_MIPS16 && !GENERATE_MIPS16E
      && !memory_operand (operands[1], <SHORT:MODE>mode))
    {
      emit_insn (gen_and<GPR:mode>3 (operands[0],
				     gen_lowpart (<GPR:MODE>mode, operands[1]),
				     force_reg (<GPR:MODE>mode,
						GEN_INT (<SHORT:mask>))));
      DONE;
    }
}
)

(define_insn "*zero_extend<SHORT:mode><GPR:mode>2"
[(set (match_operand:GPR 0 "register_operand" "=d,d") (zero_extend:DI (match_operand:SHORT 1 "nonimmediate_operand" "d,m") ) ) ]
  "!TARGET_MIPS16"
  "@
   andi\t%0,%1,<SHORT:mask>
   l<SHORT:size>u\t%0,%1"
  [(set_attr "move_type" "andi,load")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*zero_extend<SHORT:mode><GPR:mode>2_mips16e"
[(set (match_operand:GPR 0 "register_operand" "=d") (zero_extend:DI (match_operand:SHORT 1 "nonimmediate_operand" "0") ) ) ]
  "GENERATE_MIPS16E"
  "ze<SHORT:size>\t%0"
  ;; This instruction is effectively a special encoding of ANDI.
  [(set_attr "move_type" "andi")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*zero_extend<SHORT:mode><GPR:mode>2_mips16"
[(set (match_operand:GPR 0 "register_operand" "m") (zero_extend:DI (match_operand:SHORT 1 "nonimmediate_operand" ) ) ) ]
  "TARGET_MIPS16"
  "l<SHORT:size>u\t%0,%1"
  [(set_attr "move_type" "load")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_expand "zero_extendqihi2"
[(set (match_operand:HI 0 "register_operand" "") (zero_extend:DI (match_operand:QI 1 "nonimmediate_operand" "") ) ) ]
  ""
{
  if (TARGET_MIPS16 && !memory_operand (operands[1], QImode))
    {
      emit_insn (gen_zero_extendqisi2 (gen_lowpart (SImode, operands[0]),
				       operands[1]));
      DONE;
    }
}
)

(define_insn "*zero_extendqihi2"
[(set (match_operand:HI 0 "register_operand" "=d,d") (zero_extend:DI (match_operand:QI 1 "nonimmediate_operand" "d,m") ) ) ]
  "!TARGET_MIPS16"
  "@
   andi\t%0,%1,0x00ff
   lbu\t%0,%1"
  [(set_attr "move_type" "andi,load")
   (set_attr "mode" "HI")]
)

(define_insn "*zero_extendqihi2_mips16"
[(set (match_operand:HI 0 "register_operand" "=d") (zero_extend:DI (match_operand:QI 1 "nonimmediate_operand" "m") ) ) ]
  "TARGET_MIPS16"
  "lbu\t%0,%1"
  [(set_attr "move_type" "load")
   (set_attr "mode" "HI")]
)


(define_insn "*zero_extend<GPR:mode>_trunc<SHORT:mode>"
[(set (match_operand:GPR 0 "register_operand" "=d") (zero_extend:GPR (truncate:SHORT (match_operand:DI 1 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16"
{
  operands[2] = GEN_INT (GET_MODE_MASK (<SHORT:MODE>mode));
  return "andi\t%0,%1,%x2";
}
  [(set_attr "alu_type" "and")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*zero_extendhi_truncqi"
[(set (match_operand:HI 0 "register_operand" "=d") (zero_extend:GPR (truncate:QI (match_operand:DI 1 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16"
  "andi\t%0,%1,0xff"
  [(set_attr "alu_type" "and")
   (set_attr "mode" "HI")]
)



(define_insn_and_split "extendsidi2"
[(set (match_operand:DI 0 "register_operand" "=d,l,d") (sign_extend:DI (match_operand:SI 1 "nonimmediate_operand" "0,0,m") ) ) ]
  "TARGET_64BIT"
  "@
   #
   #
   lw\t%0,%1"
  "&& reload_completed && register_operand (operands[1], VOIDmode)"
[  (const_int 0) ]
{
  emit_note (NOTE_INSN_DELETED);
  DONE;
}
  [(set_attr "move_type" "move,move,load")
   (set_attr "mode" "DI")]
)

(define_expand "extend<SHORT:mode><GPR:mode>2"
[(set (match_operand:GPR 0 "register_operand" "") (sign_extend:GPR (match_operand:SHORT 1 "nonimmediate_operand" "") ) ) ]
  ""
)

(define_insn "*extend<SHORT:mode><GPR:mode>2_mips16e"
[(set (match_operand:GPR 0 "register_operand" "=d,d") (sign_extend:GPR (match_operand:SHORT 1 "nonimmediate_operand" "0,m") ) ) ]
  "GENERATE_MIPS16E"
  "@
   se<SHORT:size>\t%0
   l<SHORT:size>\t%0,%1"
  [(set_attr "move_type" "signext,load")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn_and_split "*extend<SHORT:mode><GPR:mode>2"
[(set (match_operand:GPR 0 "register_operand" "=d,d") (sign_extend:GPR (match_operand:SHORT 1 "nonimmediate_operand" "d,m") ) ) ]
  "!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E"
  "@
   #
   l<SHORT:size>\t%0,%1"
  "&& reload_completed && REG_P (operands[1])"
[  (set (match_dup 0) (ashift:GPR (match_dup 1) (match_dup 2) ) ) (set (match_dup 0) (ashiftrt:GPR (match_dup 0) (match_dup 2) ) ) ]
{
  operands[1] = gen_lowpart (<GPR:MODE>mode, operands[1]);
  operands[2] = GEN_INT (GET_MODE_BITSIZE (<GPR:MODE>mode)
			 - GET_MODE_BITSIZE (<SHORT:MODE>mode));
}
  [(set_attr "move_type" "shift_shift,load")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*extend<SHORT:mode><GPR:mode>2_se<SHORT:size>"
[(set (match_operand:GPR 0 "register_operand" "=d,d") (sign_extend:GPR (match_operand:SHORT 1 "nonimmediate_operand" "d,m") ) ) ]
  "ISA_HAS_SEB_SEH"
  "@
   se<SHORT:size>\t%0,%1
   l<SHORT:size>\t%0,%1"
  [(set_attr "move_type" "signext,load")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_expand "extendqihi2"
[(set (match_operand:HI 0 "register_operand" "") (sign_extend:GPR (match_operand:QI 1 "nonimmediate_operand" "") ) ) ]
  ""
)

(define_insn "*extendqihi2_mips16e"
[(set (match_operand:HI 0 "register_operand" "=d,d") (sign_extend:GPR (match_operand:QI 1 "nonimmediate_operand" "0,m") ) ) ]
  "GENERATE_MIPS16E"
  "@
   seb\t%0
   lb\t%0,%1"
  [(set_attr "move_type" "signext,load")
   (set_attr "mode" "SI")]
)

(define_insn_and_split "*extendqihi2"
[(set (match_operand:HI 0 "register_operand" "=d,d") (sign_extend:HI (match_operand:QI 1 "nonimmediate_operand" "d,m") ) ) ]
  "!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E"
  "@
   #
   lb\t%0,%1"
  "&& reload_completed && REG_P (operands[1])"
[  (set (match_dup 0) (ashift (match_dup 1) (match_dup 2) ) ) (set (match_dup 0) (ashiftrt:SI (match_dup 0) (match_dup 2) ) ) ]
{
  operands[0] = gen_lowpart (SImode, operands[0]);
  operands[1] = gen_lowpart (SImode, operands[1]);
  operands[2] = GEN_INT (GET_MODE_BITSIZE (SImode)
			 - GET_MODE_BITSIZE (QImode));
}
  [(set_attr "move_type" "shift_shift,load")
   (set_attr "mode" "SI")]
)

(define_insn "*extendqihi2_seb"
[(set (match_operand:HI 0 "register_operand" "=d,d") (sign_extend:GPR (match_operand:QI 1 "nonimmediate_operand" "d,m") ) ) ]
  "ISA_HAS_SEB_SEH"
  "@
   seb\t%0,%1
   lb\t%0,%1"
  [(set_attr "move_type" "signext,load")
   (set_attr "mode" "SI")]
)


(define_insn_and_split "*extenddi_truncate<mode>"
[(set (match_operand:DI 0 "register_operand" "=d") (sign_extend:DI (truncate:SHORT (match_operand:DI 1 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS"
  "#"
  "&& reload_completed"
[  (set (match_dup 2) (ashift:DI (match_dup 1) (match_dup 3) ) ) (set (match_dup 0) (ashiftrt:DI (match_dup 2) (match_dup 3) ) ) ]
{
  operands[2] = gen_lowpart (DImode, operands[0]);
  operands[3] = GEN_INT (BITS_PER_WORD - GET_MODE_BITSIZE (<MODE>mode));
}
  [(set_attr "move_type" "shift_shift")
   (set_attr "mode" "DI")]
)

(define_insn_and_split "*extendsi_truncate<mode>"
[(set (match_operand:SI 0 "register_operand" "=d") (sign_extend:SI (truncate:SHORT (match_operand:DI 1 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS"
  "#"
  "&& reload_completed"
[  (set (match_dup 2) (ashift:DI (match_dup 1) (match_dup 3) ) ) (set (match_dup 0) (truncate:SI (ashiftrt:DI (match_dup 2) (match_dup 3) ) ) ) ]
{
  operands[2] = gen_lowpart (DImode, operands[0]);
  operands[3] = GEN_INT (BITS_PER_WORD - GET_MODE_BITSIZE (<MODE>mode));
}
  [(set_attr "move_type" "shift_shift")
   (set_attr "mode" "SI")]
)

(define_insn_and_split "*extendhi_truncateqi"
[(set (match_operand:HI 0 "register_operand" "=d") (sign_extend:HI (truncate:QI (match_operand:DI 1 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS"
  "#"
  "&& reload_completed"
[  (set (match_dup 2) (ashift:DI (match_dup 1) (const_int 56) ) ) (set (match_dup 0) (truncate:HI (ashiftrt:DI (match_dup 2) (const_int 56) ) ) ) ]
{
  operands[2] = gen_lowpart (DImode, operands[0]);
}
  [(set_attr "move_type" "shift_shift")
   (set_attr "mode" "SI")]
)

(define_insn "*extend<GPR:mode>_truncate<SHORT:mode>_exts"
[(set (match_operand:GPR 0 "register_operand" "=d") (sign_extend:GPR (truncate:SHORT (match_operand:DI 1 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS"
{
  operands[2] = GEN_INT (GET_MODE_BITSIZE (<SHORT:MODE>mode));
  return "exts\t%0,%1,0,%m2";
}
  [(set_attr "type" "arith")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*extendhi_truncateqi_exts"
[(set (match_operand:HI 0 "register_operand" "=d") (sign_extend:GPR (truncate:QI (match_operand:DI 1 "register_operand" "d") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS"
  "exts\t%0,%1,0,7"
  [(set_attr "type" "arith")
   (set_attr "mode" "SI")]
)

(define_insn "extendsfdf2"
[(set (match_operand:DF 0 "register_operand" "=f") (float_extend:DF (match_operand:SF 1 "regiser_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT"
  "cvt.d.s\t%0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "cnv_mode"	"S2D")   
   (set_attr "mode"	"DF")]
)



(define_expand "fix_truncdfsi2"
[(set (match_operand:SI 0 "register_operand" "") (fix:SI (match_operand:DF 1 "register_operand" "") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT"
{
  if (!ISA_HAS_TRUNC_W)
    {
      emit_insn (gen_fix_truncdfsi2_macro (operands[0], operands[1]));
      DONE;
    }
}
)

(define_insn "fix_truncdfsi2_insn"
[(set (match_operand:SI 0 "register_operand" "=f") (fix:SI (match_operand:DF 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT && ISA_HAS_TRUNC_W"
  "trunc.w.d %0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"DF")
   (set_attr "cnv_mode"	"D2I")]
)

(define_insn "fix_truncdfsi2_macro"
[ (set (match_operand:SI 0 "register_operand" "=f") (fix:SI (match_operand:DF 1 "register_operand" "f") ) ) (clobber (match_scratch:DF 2 "=d") ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT && !ISA_HAS_TRUNC_W"
{
  if (mips_nomacro.nesting_level > 0)
    return ".set\tmacro\;trunc.w.d %0,%1,%2\;.set\tnomacro";
  else
    return "trunc.w.d %0,%1,%2";
}
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"DF")
   (set_attr "cnv_mode"	"D2I")
   (set_attr "length"	"36")]
)

(define_expand "fix_truncsfsi2"
[(set (match_operand:SI 0 "register_operand" "") (fix:DF (match_operand:DF 1 "register_operand" "") ) ) ]
  "TARGET_HARD_FLOAT"
{
  if (!ISA_HAS_TRUNC_W)
    {
      emit_insn (gen_fix_truncsfsi2_macro (operands[0], operands[1]));
      DONE;
    }
}
)

(define_insn "fix_truncsfsi2_insn"
[(set (match_operand:SI 0 "register_operand" "=f") (fix:DF (match_operand:DF 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && ISA_HAS_TRUNC_W"
  "trunc.w.s %0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"SF")
   (set_attr "cnv_mode"	"S2I")]
)

(define_insn "fix_truncsfsi2_macro"
[ (set (match_operand:SI 0 "register_operand" "=f") (fix:SI (match_operand:SF 1 "regiser_operand" "f") ) ) (clobber (match_scratch:SF 2 "=d") ) ]
  "TARGET_HARD_FLOAT && !ISA_HAS_TRUNC_W"
{
  if (mips_nomacro.nesting_level > 0)
    return ".set\tmacro\;trunc.w.s %0,%1,%2\;.set\tnomacro";
  else
    return "trunc.w.s %0,%1,%2";
}
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"SF")
   (set_attr "cnv_mode"	"S2I")
   (set_attr "length"	"36")]
)

(define_insn "fix_truncdfdi2"
[(set (match_operand:DI 0 "register_operand" "=f") (fix:DF (match_operand:DF 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT"
  "trunc.l.d %0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"DF")
   (set_attr "cnv_mode"	"D2I")]
)

(define_insn "fix_truncsfdi2"
[(set (match_operand:DI 0 "register_operand" "=f") (fix:DF (match_operand:DF 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT"
  "trunc.l.s %0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"SF")
   (set_attr "cnv_mode"	"S2I")]
)

(define_insn "floatsidf2"
[(set (match_operand:DF 0 "register_operand" "=f") (float (match_operand:SI 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT"
  "cvt.d.w\t%0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"DF")
   (set_attr "cnv_mode"	"I2D")]
)

(define_insn "floatdidf2"
[(set (match_operand:DF 0 "register_operand" "=f") (float (match_operand:DI 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT"
  "cvt.d.l\t%0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"DF")
   (set_attr "cnv_mode"	"I2D")]
)

(define_insn "floatsisf2"
[(set (match_operand:SF 0 "register_operand" "=f") (float (match_operand:SI 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT"
  "cvt.s.w\t%0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"SF")
   (set_attr "cnv_mode"	"I2S")]
)

(define_insn "floatdisf2"
[(set (match_operand:SF 0 "register_operand" "=f") (float (match_operand:DI 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT"
  "cvt.s.l\t%0,%1"
  [(set_attr "type"	"fcvt")
   (set_attr "mode"	"SF")
   (set_attr "cnv_mode"	"I2S")]
)

(define_expand "fixuns_truncdfsi2"
[(set (match_operand:SI 0 "register_operand" "") (unsigned_fix:SI (match_operand:DF 1 "register_operand" "") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT"
{
  rtx reg1 = gen_reg_rtx (DFmode);
  rtx reg2 = gen_reg_rtx (DFmode);
  rtx reg3 = gen_reg_rtx (SImode);
  rtx label1 = gen_label_rtx ();
  rtx label2 = gen_label_rtx ();
  rtx test;
  REAL_VALUE_TYPE offset;
  real_2expN (&offset, 31, DFmode);
  if (reg1)			/* Turn off complaints about unreached code.  */
    {
      mips_emit_move (reg1, CONST_DOUBLE_FROM_REAL_VALUE (offset, DFmode));
      do_pending_stack_adjust ();
      test = gen_rtx_GE (VOIDmode, operands[1], reg1);
      emit_jump_insn (gen_cbranchdf4 (test, operands[1], reg1, label1));
      emit_insn (gen_fix_truncdfsi2 (operands[0], operands[1]));
      emit_jump_insn (gen_rtx_SET (VOIDmode, pc_rtx,
				   gen_rtx_LABEL_REF (VOIDmode, label2)));
      emit_barrier ();
      emit_label (label1);
      mips_emit_move (reg2, gen_rtx_MINUS (DFmode, operands[1], reg1));
      mips_emit_move (reg3, GEN_INT (trunc_int_for_mode
				     (BITMASK_HIGH, SImode)));
      emit_insn (gen_fix_truncdfsi2 (operands[0], reg2));
      emit_insn (gen_iorsi3 (operands[0], operands[0], reg3));
      emit_label (label2);
      /* Allow REG_NOTES to be set on last insn (labels don't have enough
	 fields, and can't be used for REG_NOTES anyway).  */
      emit_use (stack_pointer_rtx);
      DONE;
    }
}
)

(define_expand "fixuns_truncdfdi2"
[(set (match_operand:DI 0 "register_operand" "") (unsigned_fix:DI (match_operand:DF 1 "register_operand" "") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_64BIT && TARGET_DOUBLE_FLOAT"
{
  rtx reg1 = gen_reg_rtx (DFmode);
  rtx reg2 = gen_reg_rtx (DFmode);
  rtx reg3 = gen_reg_rtx (DImode);
  rtx label1 = gen_label_rtx ();
  rtx label2 = gen_label_rtx ();
  rtx test;
  REAL_VALUE_TYPE offset;
  real_2expN (&offset, 63, DFmode);
  mips_emit_move (reg1, CONST_DOUBLE_FROM_REAL_VALUE (offset, DFmode));
  do_pending_stack_adjust ();
  test = gen_rtx_GE (VOIDmode, operands[1], reg1);
  emit_jump_insn (gen_cbranchdf4 (test, operands[1], reg1, label1));
  emit_insn (gen_fix_truncdfdi2 (operands[0], operands[1]));
  emit_jump_insn (gen_rtx_SET (VOIDmode, pc_rtx,
			       gen_rtx_LABEL_REF (VOIDmode, label2)));
  emit_barrier ();
  emit_label (label1);
  mips_emit_move (reg2, gen_rtx_MINUS (DFmode, operands[1], reg1));
  mips_emit_move (reg3, GEN_INT (BITMASK_HIGH));
  emit_insn (gen_ashldi3 (reg3, reg3, GEN_INT (32)));
  emit_insn (gen_fix_truncdfdi2 (operands[0], reg2));
  emit_insn (gen_iordi3 (operands[0], operands[0], reg3));
  emit_label (label2);
  /* Allow REG_NOTES to be set on last insn (labels don't have enough
     fields, and can't be used for REG_NOTES anyway).  */
  emit_use (stack_pointer_rtx);
  DONE;
}
)

(define_expand "fixuns_truncsfsi2"
[(set (match_operand:SI 0 "register_operand" "") (unsigned_fix:SI (match_operand:SF 1 "register_operand" "") ) ) ]
  "TARGET_HARD_FLOAT"
{
  rtx reg1 = gen_reg_rtx (SFmode);
  rtx reg2 = gen_reg_rtx (SFmode);
  rtx reg3 = gen_reg_rtx (SImode);
  rtx label1 = gen_label_rtx ();
  rtx label2 = gen_label_rtx ();
  rtx test;
  REAL_VALUE_TYPE offset;
  real_2expN (&offset, 31, SFmode);
  mips_emit_move (reg1, CONST_DOUBLE_FROM_REAL_VALUE (offset, SFmode));
  do_pending_stack_adjust ();
  test = gen_rtx_GE (VOIDmode, operands[1], reg1);
  emit_jump_insn (gen_cbranchsf4 (test, operands[1], reg1, label1));
  emit_insn (gen_fix_truncsfsi2 (operands[0], operands[1]));
  emit_jump_insn (gen_rtx_SET (VOIDmode, pc_rtx,
			       gen_rtx_LABEL_REF (VOIDmode, label2)));
  emit_barrier ();
  emit_label (label1);
  mips_emit_move (reg2, gen_rtx_MINUS (SFmode, operands[1], reg1));
  mips_emit_move (reg3, GEN_INT (trunc_int_for_mode
				 (BITMASK_HIGH, SImode)));
  emit_insn (gen_fix_truncsfsi2 (operands[0], reg2));
  emit_insn (gen_iorsi3 (operands[0], operands[0], reg3));
  emit_label (label2);
  /* Allow REG_NOTES to be set on last insn (labels don't have enough
     fields, and can't be used for REG_NOTES anyway).  */
  emit_use (stack_pointer_rtx);
  DONE;
}
)

(define_expand "fixuns_truncsfdi2"
[(set (match_operand:DI 0 "register_operand" "") (unsigned_fix:SI (match_operand:SF 1 "register_operand" "") ) ) ]
  "TARGET_HARD_FLOAT && TARGET_64BIT && TARGET_DOUBLE_FLOAT"
{
  rtx reg1 = gen_reg_rtx (SFmode);
  rtx reg2 = gen_reg_rtx (SFmode);
  rtx reg3 = gen_reg_rtx (DImode);
  rtx label1 = gen_label_rtx ();
  rtx label2 = gen_label_rtx ();
  rtx test;
  REAL_VALUE_TYPE offset;
  real_2expN (&offset, 63, SFmode);
  mips_emit_move (reg1, CONST_DOUBLE_FROM_REAL_VALUE (offset, SFmode));
  do_pending_stack_adjust ();
  test = gen_rtx_GE (VOIDmode, operands[1], reg1);
  emit_jump_insn (gen_cbranchsf4 (test, operands[1], reg1, label1));
  emit_insn (gen_fix_truncsfdi2 (operands[0], operands[1]));
  emit_jump_insn (gen_rtx_SET (VOIDmode, pc_rtx,
			       gen_rtx_LABEL_REF (VOIDmode, label2)));
  emit_barrier ();
  emit_label (label1);
  mips_emit_move (reg2, gen_rtx_MINUS (SFmode, operands[1], reg1));
  mips_emit_move (reg3, GEN_INT (BITMASK_HIGH));
  emit_insn (gen_ashldi3 (reg3, reg3, GEN_INT (32)));
  emit_insn (gen_fix_truncsfdi2 (operands[0], reg2));
  emit_insn (gen_iordi3 (operands[0], operands[0], reg3));
  emit_label (label2);
  /* Allow REG_NOTES to be set on last insn (labels don't have enough
     fields, and can't be used for REG_NOTES anyway).  */
  emit_use (stack_pointer_rtx);
  DONE;
}
)



(define_expand "extv"
[(set (match_operand 0 "register_operand" "") (sign_extract (match_operand 1 "nonimmediate_operand" "") (match_operand 2 "const_int_operand" "") (match_operand 3 "const_int_operand" "") ) ) ]
  "!TARGET_MIPS16"
{
  if (mips_expand_ext_as_unaligned_load (operands[0], operands[1],
					 INTVAL (operands[2]),
					 INTVAL (operands[3])))
    DONE;
  else if (register_operand (operands[1], GET_MODE (operands[0]))
	   && ISA_HAS_EXTS && UINTVAL (operands[2]) <= 32)
    {
      if (GET_MODE (operands[0]) == DImode)
	emit_insn (gen_extvdi (operands[0], operands[1], operands[2],
			       operands[3]));
      else
	emit_insn (gen_extvsi (operands[0], operands[1], operands[2],
			       operands[3]));
      DONE;
    }
  else
    FAIL;
}
)

(define_insn "extv<mode>"
[(set (match_operand:GPR 0 "register_operand" "=d") (sign_extract:GPR (match_operand:GPR 1 "nonimmediate_operand" "d") (match_operand 2 "const_int_operand" ) (match_operand 3 "const_int_operand" ) ) ) ]
  "ISA_HAS_EXTS && UINTVAL (operands[2]) <= 32"
  "exts\t%0,%1,%3,%m2"
  [(set_attr "type"     "arith")
   (set_attr "mode"     "<MODE>")]
)

(define_expand "extzv"
[(set (match_operand 0 "register_operand" "") (zero_extract (match_operand 1 "nonimmediate_operand" "") (match_operand 2 "const_int_operand" "") (match_operand 3 "const_int_operand" "") ) ) ]
	"!TARGET_MIPS16"
{
  if (mips_expand_ext_as_unaligned_load (operands[0], operands[1],
					 INTVAL (operands[2]),
					 INTVAL (operands[3])))
    DONE;
  else if (mips_use_ins_ext_p (operands[1], INTVAL (operands[2]),
			       INTVAL (operands[3])))
    {
      if (GET_MODE (operands[0]) == DImode)
        emit_insn (gen_extzvdi (operands[0], operands[1], operands[2],
				operands[3]));
      else
        emit_insn (gen_extzvsi (operands[0], operands[1], operands[2],
				operands[3]));
      DONE;
    }
  else
    FAIL;
}
)

(define_insn "extzv<mode>"
[(set (match_operand:GPR 0 "register_operand" "=d") (zero_extract:GPR (match_operand:GPR 1 "nonimmediate_operand" "d") (match_operand 2 "const_int_operand" ) (match_operand 3 "const_int_operand" ) ) ) ]
  "mips_use_ins_ext_p (operands[1], INTVAL (operands[2]),
		       INTVAL (operands[3]))"
  "<d>ext\t%0,%1,%3,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"<MODE>")]
)

(define_insn "*extzv_truncsi_exts"
[(set (match_operand:SI 0 "register_operand" "=d") (truncate:SI (zero_extract:DI (match_operand:DI 1 "register_operand" "d") (match_operand 2 "const_int_operand" "") (match_operand 3 "const_int_operand" "") ) ) ) ]
  "ISA_HAS_EXTS && TARGET_64BIT && IN_RANGE (INTVAL (operands[2]), 32, 63)"
  "exts\t%0,%1,%3,31"
  [(set_attr "type"     "arith")
   (set_attr "mode"     "SI")]
)

(define_expand "insv"
[(set (zero_extract (match_operand 0 "nonimmediate_operand" "") (match_operand 1 "immediate_operand" "") (match_operand 2 "immediate_operand" "") ) (match_operand 3 "reg_or_0_operand" "") ) ]
  "!TARGET_MIPS16"
{
  if (mips_expand_ins_as_unaligned_store (operands[0], operands[3],
					  INTVAL (operands[1]),
					  INTVAL (operands[2])))
    DONE;
  else if (mips_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			       INTVAL (operands[2])))
    {
      if (GET_MODE (operands[0]) == DImode)
        emit_insn (gen_insvdi (operands[0], operands[1], operands[2],
			       operands[3]));
      else
        emit_insn (gen_insvsi (operands[0], operands[1], operands[2],
			       operands[3]));
      DONE;
   }
   else
     FAIL;
}
)

(define_insn "insv<mode>"
[(set (zero_extract:GPR (match_operand:GPR 0 "nonimmediate_operand" "+d") (match_operand:SI 1 "immediate_operand" "I") (match_operand:SI 2 "immediate_operand" "I") ) (match_operand:GPR 3 "reg_or_0_operand" "dJ") ) ]
  "mips_use_ins_ext_p (operands[0], INTVAL (operands[1]),
		       INTVAL (operands[2]))"
  "<d>ins\t%0,%z3,%2,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"<MODE>")]
)


(define_insn "*cins<mode>"
[(set (match_operand:GPR 0 "register_operand" "=d") (and:GPR (ashift:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "const_int_operand" "") ) (match_operand:GPR 3 "const_int_operand" "") ) ) ]
  "ISA_HAS_CINS
   && mask_low_and_shift_p (<MODE>mode, operands[3], operands[2], 32)"
{
  operands[3] =
    GEN_INT (mask_low_and_shift_len (<MODE>mode, operands[3], operands[2]));
  return "cins\t%0,%1,%2,%m3";
}
  [(set_attr "type"     "shift")
   (set_attr "mode"     "<MODE>")]
)


(define_insn "mov_<load>l"
[(set (match_operand:GPR 0 "register_operand" "=d") (unspec:GPR [(match_operand:BLK 1 "memory_operand" "m") (match_operand:QI 2 "memory_operand" "m") (UNSPEC_LOAD_LEFT) ) ) ]
  "!TARGET_MIPS16 && mips_mem_fits_mode_p (<MODE>mode, operands[1])"
  "<load>l\t%0,%2"
  [(set_attr "move_type" "load")
   (set_attr "mode" "<MODE>")]
)

(define_insn "mov<load>r"
[(set (match_operand:GPR 0 "register_operand" "=d") (unspec:GPR [(match_operand:BLK 1 "memory_operand" "m") (match_operand:QI 2 "memory_operand" "m") (match_operand:GPR 3 "register_operand" "0") (UNSPEC_LOAD_RIGHT) ) ) ]
  "!TARGET_MIPS16 && mips_mem_fits_mode_p (<MODE>mode, operands[1])"
  "<load>r\t%0,%2"
  [(set_attr "move_type" "load")
   (set_attr "mode" "<MODE>")]
)

(define_insn "mov_<store>l"
[(set (match_operand:BLK 0 "smemory_operand" "=m") (unspec:BLK [(match_operand:GPR 1 "reg_or_0_operand" "dJ") (match_operand:QI 2 "memory_operand" "m") (UNSPEC_STORE_LEFT) ) ) ]
  "!TARGET_MIPS16 && mips_mem_fits_mode_p (<MODE>mode, operands[0])"
  "<store>l\t%z1,%2"
  [(set_attr "move_type" "store")
   (set_attr "mode" "<MODE>")]
)

(define_insn "mov_<store>r"
[(set (match_operand:BLK 0 "memory_operand" "+m") (unspec [(match_operand:GPR 1 "reg_or_0_operand" "dJ") (match_operand:QI 2 "memory_operand" "m") (match_dup 0) (UNSPEC_STORE_RIGHT) ) ) ]
  "!TARGET_MIPS16 && mips_mem_fits_mode_p (<MODE>mode, operands[0])"
  "<store>r\t%z1,%2"
  [(set_attr "move_type" "store")
   (set_attr "mode" "<MODE>")]
)


(define_insn_and_split "*lea_high64"
[(set (match_operand:DI 0 "register_operand" "=d") (high:DI (match_operand:DI 1 "absolute_symbolic_operand" "") ) ) ]
  "TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS"
  "#"
  "&& epilogue_completed"
[  (set (match_dup 0) (high:DI (match_dup 2) ) ) (set (match_dup 0) (lo_sum:DI (match_dup 0) (match_dup 2) ) ) (set (match_dup 0) (ashift:DI (match_dup 0) (const_int 16) ) ) (set (match_dup 0) (lo_sum:DI (match_dup 0) (match_dup 3) ) ) (set (match_dup 0) (ashift:DI (match_dup 0) (const_int 16) ) ) ]
{
  operands[2] = mips_unspec_address (operands[1], SYMBOL_64_HIGH);
  operands[3] = mips_unspec_address (operands[1], SYMBOL_64_MID);
}
  [(set_attr "length" "20")]
)


(define_peephole2 
[ (set (match_operand:DI 1 "d_operand" "") (high (match_operand:DI 2 "absolute_symbolic_operand" "") ) )  (match_scratch:DI 0 "d") ]
  "TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS"
[  (set (match_dup 1) (high:DI (match_dup 3) ) ) (set (match_dup 0) (high:DI (match_dup 4) ) ) (set (match_dup 1) (lo_sum:DI (match_dup 1) (match_dup 3) ) ) (set (match_dup 1) (ashift:DI (match_dup 1) (const_int 32) ) ) (set (duplicate1) (plus:DI (match_dup 1) (match_dup 0) ) ) ]
{
  operands[3] = mips_unspec_address (operands[2], SYMBOL_64_HIGH);
  operands[4] = mips_unspec_address (operands[2], SYMBOL_64_LOW);
}
)


(define_insn_and_split "*lea64"
[ (set (match_operand:DI 0 "register_operand" "=d") (match_operand:DI 1 "absolute_symbolic_operand" "") ) (clobber (match_scratch:DI 2 "=&d") ) ]
  "TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS && cse_not_expected"
  "#"
  "&& reload_completed"
[  (set (match_dup 0) (high:DI (match_dup 3) ) ) (set (match_dup 2) (high:DI (match_dup 4) ) ) (set (match_dup 0) (lo_sum:DI (match_dup 0) (match_dup 3) ) ) (set (match_dup 2) (lo_sum:DI (match_dup 2) (match_dup 4) ) ) (set (match_dup 0) (ashift:DI (match_dup 0) (const_int 32) ) ) (set (match_dup 0) (plus:DI (match_dup 0) (match_dup 2) ) ) ]
{
  operands[3] = mips_unspec_address (operands[1], SYMBOL_64_HIGH);
  operands[4] = mips_unspec_address (operands[1], SYMBOL_64_LOW);
}
  [(set_attr "length" "24")]
)


(define_split 
[(set (match_operand:P 0 "d_operand" "") (high:P (match_operand:P 1 "symbolic_operand_with_high" "") ) ) ]
  "TARGET_MIPS16 && reload_completed"
[  (set (match_dup 0) (unspec:P [(match_dup 1) (UNSPEC_UNSHIFTED_HIGH) ) ) (set (match_dup 0) (ashift:P (match_dup 0) (const_int 16) ) ) ]
)

(define_insn "*unshifted_high"
[(set (match_operand:P 0 "d_operand" "=d") (unspec:P [(match_operand:P 1 "symbolic_operand_with_help" "") (UNSPEC_UNSHIFTED_HIGH) ) ) ]
  ""
  "li\t%0,%h1"
  [(set_attr "extended_mips16" "yes")]
)


(define_insn_and_split "*xgot_hi<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (high:P (match_operand:P 1 "got_disp_operand" "") ) ) ]
  "TARGET_EXPLICIT_RELOCS && TARGET_XGOT"
  "#"
  "&& reload_completed"
[  (set (match_dup 0) (high:P (match_dup 2) ) ) (set (match_dup 0) (plus:P (match_dup 0) (match_dup 3) ) ) ]
{
  operands[2] = mips_unspec_address (operands[1], SYMBOL_GOTOFF_DISP);
  operands[3] = pic_offset_table_rtx;
}
  [(set_attr "got" "xgot_high")
   (set_attr "mode" "<MODE>")]
)

(define_insn_and_split "*xgot_lo<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (lo_sum:P (match_operand:P 1 "register_operand" "d") (match_operand:P 2 "got_disp_operand" "") ) ) ]
  "TARGET_EXPLICIT_RELOCS && TARGET_XGOT"
  "#"
  "&& reload_completed"
[ (set (match_dup 0) (unspec:P [(match_dup 1) (match_dup 3) (UNSPEC_LOAD_GOT) ) ) ]
  { operands[3] = mips_unspec_address (operands[2], SYMBOL_GOTOFF_DISP); }
  [(set_attr "got" "load")
   (set_attr "mode" "<MODE>")]
)


(define_insn_and_split "*got_disp<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (match_operand:P 1 "got_disp_operand" "") ) ]
  "TARGET_EXPLICIT_RELOCS && !mips_split_p[SYMBOL_GOT_DISP]"
  "#"
  "&& reload_completed"
[ (set (match_dup 0) (match_dup 2) ) ]
  { operands[2] = mips_got_load (NULL, operands[1], SYMBOL_GOTOFF_DISP); }
  [(set_attr "got" "load")
   (set_attr "mode" "<MODE>")]
)


(define_insn_and_split "*got_page<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (high:P (match_operand:P 1 "got_page_ofst_operand" "") ) ) ]
  "TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]"
  "#"
  "&& reload_completed"
[ (set (match_dup 0) (match_dup 2) ) ]
  { operands[2] = mips_got_load (NULL, operands[1], SYMBOL_GOTOFF_PAGE); }
  [(set_attr "got" "load")
   (set_attr "mode" "<MODE>")]
)


(define_expand "unspec_got_<mode>"
[(unspec [(match_operand:P 0 "" "") (match_operand:P 1 "" "") ) ]
)


(define_insn "load_got<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (unspec:P [(match_operand:P 1 "register_operand" "d") (match_operand:P 2 "immediate_operand" "") (UNSPEC_LOAD_GOT) ) ) ]
  ""
  "<load>\t%0,%R2(%1)"
  [(set_attr "got" "load")
   (set_attr "mode" "<MODE>")]
)


(define_insn "*low<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (lo_sum:P (match_operand:P 1 "register_operand" "d") (match_operand:P 2 "nonimmediate_operand" "") ) ) ]
  "!TARGET_MIPS16"
  "<d>addiu\t%0,%1,%R2"
  [(set_attr "alu_type" "add")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*low<mode>_mips16"
[(set (match_operand:P 0 "register_operand" "=d") (lo_sum:P (match_operand:P 1 "register_operand" "0") (match_operand:P 2 "nonimmediate_operand" "") ) ) ]
  "TARGET_MIPS16"
  "<d>addiu\t%0,%R2"
  [(set_attr "alu_type" "add")
   (set_attr "mode" "<MODE>")
   (set_attr "extended_mips16" "yes")]
)


(define_split 
[(set (match_operand:GPR 0 "d_operand" "") (const:GPR (unspec:GPR [(const_int 0) (UNSPEC_GP) ) ) ) ]
  "TARGET_MIPS16 && TARGET_USE_GOT && reload_completed"
[ (set (match_dup 0) (match_dup 1) ) ]
  { operands[1] = pic_offset_table_rtx; }
)


(define_split 
[ (set (match_operand:GPR 0 "register_operand" "") (match_operand:GPR 1 "splittable_const_int_operand" "") ) (clobber (match_operand:GPR 2 "register_operand" "") ) ]
  ""
[  (const_int 0) ]
{
  mips_move_integer (operands[2], operands[0], INTVAL (operands[1]));
  DONE;
}
)


(define_split 
[ (set (match_operand:P 0 "register_operand" "") (match_operand:P 1 "" "") ) (clobber (match_operand:P 2 "register_operand" "") ) ]
  "mips_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)"
[ (set (match_dup 0) (match_dup 3) ) ]
{
  mips_split_symbol (operands[2], operands[1],
		     MAX_MACHINE_MODE, &operands[3]);
}
)


(define_expand "movdi"
[(set (match_operand:DI 0 "" "") (match_operand:DI 1 "" "") ) ]
  ""
{
  if (mips_legitimize_move (DImode, operands[0], operands[1]))
    DONE;
}
)


(define_insn "*mov<mode>_ra"
[(set (match_operand:GPR 0 "stack_operand" "=m") (reg:GPR RETURN_ADDR_REGNUM) ) ]
  "TARGET_MIPS16"
  "<store>\t$31,%0"
  [(set_attr "move_type" "store")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*movdi_32bit"
[(set (match_operand:DI 0 "nonimmediate_operand" "=d,d,d,m,*a,*d,*f,*f,*d,*m,*B*C*D,*B*C*D,*d,*m") (match_operand:DI 1 "move_operand" "d,i,m,d,*J*d,*a,*J*d,*m,*f,*f,*d,*m,*B*C*D,*B*C*D") ) ]
  "!TARGET_64BIT && !TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,const,load,store,mthilo,mfhilo,mtc,fpload,mfc,fpstore,mtc,fpload,mfc,fpstore")
   (set_attr "mode" "DI")]
)

(define_insn "*movdi_32bit_mips16"
[(set (match_operand:DI 0 "nonimmediate_operand" "=d,y,d,d,d,d,m,*d") (match_operand:DI 1 "move_operand" "d,d,y,K,N,m,d,*x") ) ]
  "!TARGET_64BIT && TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,move,move,const,constN,load,store,mfhilo")
   (set_attr "mode" "DI")]
)

(define_insn "*movdi_64bit"
[(set (match_operand:DI 0 "nonimmediate_operand" "=d,d,e,d,m,*f,*f,*d,*m,*a,*d,*B*C*D,*B*C*D,*d,*m") (match_operand:DI 1 "move_operand" "d,U,T,m,dJ,*d*J,*m,*f,*f,*J*d,*a,*d,*m,*B*C*D,*B*C*D") ) ]
  "TARGET_64BIT && !TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,const,const,load,store,mtc,fpload,mfc,fpstore,mthilo,mfhilo,mtc,fpload,mfc,fpstore")
   (set_attr "mode" "DI")]
)

(define_insn "*movdi_64bit_mips16"
[(set (match_operand:DI 0 "nonimmediate_operand" "=d,y,d,d,d,d,d,d,m,*d") (match_operand:DI 1 "move_operand" "d,d,y,K,N,U,kf,m,d,*a") ) ]
  "TARGET_64BIT && TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,move,move,const,constN,const,loadpool,load,store,mfhilo")
   (set_attr "mode" "DI")]
)


(define_split 
[(set (match_operand:DI 0 "d_operand" "") (mem:DI (plus:DI (match_dup 0) (match_operand:DI 1 "const_int_operand" "") ) ) ) ]
  "TARGET_64BIT && TARGET_MIPS16 && reload_completed
   && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x10)
       || (INTVAL (operands[1]) >= 32 * 8
	   && INTVAL (operands[1]) <= 31 * 8 + 0x8)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 8
	   && (INTVAL (operands[1]) & 7) != 0))"
[  (set (match_dup 0) (plus:DI (match_dup 0) (match_dup 1) ) ) (set (match_dup 0) (mem:DI (plus:DI (match_dup 0) (match_dup 0) ) ) ) (match_dup 2) ]
{
  HOST_WIDE_INT val = INTVAL (operands[1]);
  if (val < 0)
    operands[2] = const0_rtx;
  else if (val >= 32 * 8)
    {
      int off = val & 7;
      operands[1] = GEN_INT (0x8 + off);
      operands[2] = GEN_INT (val - off - 0x8);
    }
  else
    {
      int off = val & 7;
      operands[1] = GEN_INT (off);
      operands[2] = GEN_INT (val - off);
    }
}
)


(define_expand "mov<mode>"
[(set (match_operand:IMOVE32 0 "" "") (match_operand:IMOVE32 1 "" "") ) ]
  ""
{
  if (mips_legitimize_move (<MODE>mode, operands[0], operands[1]))
    DONE;
}
)


(define_insn "*mov<mode>_internal"
[(set (match_operand:IMOVE32 0 "nonimmediate_operand" "=d,d,e,d,m,*f,*f,*d,*m,*d,*z,*a,*d,*B*C*D,*B*C*D,*d,*m") (match_operand:IMOVE32 1 "move_operand" "d,U,T,m,dJ,*d*J,*m,*f,*f,*z,*d,*J*d,*a,*d,*m,*B*C*D,*B*C*D") ) ]
  "!TARGET_MIPS16
   && (register_operand (operands[0], <MODE>mode)
       || reg_or_0_operand (operands[1], <MODE>mode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,const,const,load,store,mtc,fpload,mfc,fpstore,mfc,mtc,mthilo,mfhilo,mtc,fpload,mfc,fpstore")
   (set_attr "mode" "SI")]
)

(define_insn "*mov<mode>_mips16"
[(set (match_operand:IMOVE32 0 "nonimmediate_operand" "=d,y,d,d,d,d,d,d,m,*d") (match_operand:IMOVE32 1 "move_operand" "d,d,y,K,N,U,kf,m,d,*a") ) ]
  "TARGET_MIPS16
   && (register_operand (operands[0], <MODE>mode)
       || register_operand (operands[1], <MODE>mode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,move,move,const,constN,const,loadpool,load,store,mfhilo")
   (set_attr "mode" "SI")]
)


(define_split 
[(set (match_operand:SI 0 "d_operand" "") (mem:SI (plus:SI (match_dup 0) (match_operand:SI 1 "const_int_operand" "") ) ) ) ]
  "TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32 * 4
	   && INTVAL (operands[1]) <= 31 * 4 + 0x7c)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 4
	   && (INTVAL (operands[1]) & 3) != 0))"
[  (set (match_dup 0) (plus:SI (match_dup 0) (match_dup 1) ) ) (set (match_dup 0) (mem:SI (plus:SI (match_dup 0) (match_dup 2) ) ) ) ]
{
  HOST_WIDE_INT val = INTVAL (operands[1]);
  if (val < 0)
    operands[2] = const0_rtx;
  else if (val >= 32 * 4)
    {
      int off = val & 3;
      operands[1] = GEN_INT (0x7c + off);
      operands[2] = GEN_INT (val - off - 0x7c);
    }
  else
    {
      int off = val & 3;
      operands[1] = GEN_INT (off);
      operands[2] = GEN_INT (val - off);
    }
}
)


(define_split 
[(set (match_operand:SI 0 "d_operand" "const_int_operand") (match_operand:SI 1 "const_int_operand" "") ) ]
  "TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[1]) >= 0x100
   && INTVAL (operands[1]) <= 0xff + 0x7f"
[  (set (match_dup 0) (match_dup 1) ) (set (match_dup 0) (plus (match_dup 0) (match_dup 2) ) ) ]
{
  int val = INTVAL (operands[1]);
  operands[1] = GEN_INT (0xff);
  operands[2] = GEN_INT (val - 0xff);
}
)


(define_insn "movcc"
[(set (match_operand:CC 0 "nonimmediate_operand" "=d,*d,*d,*m,*d,*f,*f,*f,*m") (match_operand:CC 1 "general_operand" "z,*d,*m,*d,*f,*d,*f,*m,*f") ) ]
  "ISA_HAS_8CC && TARGET_HARD_FLOAT"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "lui_movf,move,load,store,mfc,mtc,fmove,fpload,fpstore")
   (set_attr "mode" "SI")]
)


(define_expand "reload_incc"
[ (set (match_operand:CC 0 "fcc_reload_operand" "=z") (match_operand:CC 1 "general_operand" "") ) (clobber (match_operand:TF 2 "register_operand" "=&f") ) ]
  "ISA_HAS_8CC && TARGET_HARD_FLOAT"
{
  mips_expand_fcc_reload (operands[0], operands[1], operands[2]);
  DONE;
}
)

(define_expand "reload_outcc"
[ (set (match_operand:CC 0 "fcc_reload_operand" "=z") (match_operand:CC 1 "register_operand" "") ) (clobber (match_operand:TF 2 "register_operand" "=&f") ) ]
  "ISA_HAS_8CC && TARGET_HARD_FLOAT"
{
  mips_expand_fcc_reload (operands[0], operands[1], operands[2]);
  DONE;
}
)


(define_insn "*<ANYF:loadx>_<P:mode>"
[(set (match_operand:ANYF 0 "register_operand" "=f") (mem:ANYF (plus:P (match_operand:P 1 "register_operand" "d") (match_operand:P 2 "register_operand" "d") ) ) ) ]
  "ISA_HAS_FP4"
  "<ANYF:loadx>\t%0,%1(%2)"
  [(set_attr "type" "fpidxload")
   (set_attr "mode" "<ANYF:UNITMODE>")]
)

(define_insn "*<ANYF:storex>_<P:mode>"
[(set (mem:ANYf (plus:P (match_operand:P 0 "register_operand" "d") (match_operand:P 1 "register_operand" "d") ) ) (match_operand:ANYF 2 "register_operand" "f") ) ]
  "ISA_HAS_FP4"
  "<ANYF:storex>\t%0,%1(%2)"
  [(set_attr "type" "fpidxstore")
   (set_attr "mode" "<ANYF:UNITMODE>")]
)


(define_insn "*lwxs"
[(set (match_operand:IMOVE32 0 "register_operand" "=d") (mem:IMOVE32 (plus:P (mult:P (match_operand:P 1 "register_operand" "d") (match_operand:P 2 "register_operand" "d") ) ) ) ) ]
  "ISA_HAS_LWXS"
  "lwxs\t%0,%1(%2)"
  [(set_attr "type"	"load")
   (set_attr "mode"	"SI")]
)


(define_expand "movhi"
[(set (match_operand:HI 0 "" "") (match_operand:HI 1 "" "") ) ]
  ""
{
  if (mips_legitimize_move (HImode, operands[0], operands[1]))
    DONE;
}
)

(define_insn "*movhi_internal"
[(set (match_operand:HI 0 "nonimmediate_operand" "=d,d,d,m,*a,*d") (match_operand:HI 1 "move_operand" "d,I,m,dJ,*d*J,*a") ) ]
  "!TARGET_MIPS16
   && (register_operand (operands[0], HImode)
       || reg_or_0_operand (operands[1], HImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,const,load,store,mthilo,mfhilo")
   (set_attr "mode" "HI")]
)

(define_insn "*movhi_mips16"
[(set (match_operand:HI 0 "nonimmediate_operand" "=d,y,d,d,d,d,m,*d") (match_operand:HI 1 "move_operand" "d,d,y,K,N,m,d,*a") ) ]
  "TARGET_MIPS16
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,move,move,const,constN,load,store,mfhilo")
   (set_attr "mode" "HI")]
)


(define_split 
[(set (match_operand:HI 0 "d_operand" "") (mem:HI (plus:SI (match_dup 0) (match_operand:SI 1 "const_int_operand" "") ) ) ) ]
  "TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32 * 2
	   && INTVAL (operands[1]) <= 31 * 2 + 0x7e)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 2
	   && (INTVAL (operands[1]) & 1) != 0))"
[  (set (match_dup 0) (plus:SI (match_dup 0) (match_dup 1) ) ) (set (match_dup 0) (mem:HI (plus:SI (match_dup 0) (match_dup 2) ) ) ) ]
{
  HOST_WIDE_INT val = INTVAL (operands[1]);
  if (val < 0)
    operands[2] = const0_rtx;
  else if (val >= 32 * 2)
    {
      int off = val & 1;
      operands[1] = GEN_INT (0x7e + off);
      operands[2] = GEN_INT (val - off - 0x7e);
    }
  else
    {
      int off = val & 1;
      operands[1] = GEN_INT (off);
      operands[2] = GEN_INT (val - off);
    }
}
)


(define_expand "movqi"
[(set (match_operand:QI 0 "" "") (match_operand:QI 1 "" "") ) ]
  ""
{
  if (mips_legitimize_move (QImode, operands[0], operands[1]))
    DONE;
}
)

(define_insn "*movqi_internal"
[(set (match_operand:QI 0 "nonimmediate_operand" "=d,d,d,m,*a,*d") (match_operand:QI 1 "move_operand" "d,I,m,dJ,*d*J,*a") ) ]
  "!TARGET_MIPS16
   && (register_operand (operands[0], QImode)
       || reg_or_0_operand (operands[1], QImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,const,load,store,mthilo,mfhilo")
   (set_attr "mode" "QI")]
)

(define_insn "*movqi_mips16"
[(set (match_operand:QI 0 "nonimmediate_operand" "=d,y,d,d,d,d,m,*d") (match_operand:QI 1 "move_operand" "d,d,y,K,N,m,d,*a") ) ]
  "TARGET_MIPS16
   && (register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,move,move,const,constN,load,store,mfhilo")
   (set_attr "mode" "QI")]
)


(define_split 
[(set (match_operand:QI 0 "d_operand" "") (mem:QI (plus:SI (match_dup 0) (match_operand:SI 1 "const_int_operand" "") ) ) ) ]
  "TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32
	   && INTVAL (operands[1]) <= 31 + 0x7f))"
[  (set (match_dup 0) (plus:SI (match_dup 0) (match_dup 1) ) ) (set (match_dup 0) (mem:QI (plus:SI (match_dup 0) (match_dup 2) ) ) ) ]
{
  HOST_WIDE_INT val = INTVAL (operands[1]);
  if (val < 0)
    operands[2] = const0_rtx;
  else
    {
      operands[1] = GEN_INT (0x7f);
      operands[2] = GEN_INT (val - 0x7f);
    }
}
)


(define_expand "movsf"
[(set (match_operand:SF 0 "" "") (match_operand:SF 1 "" "") ) ]
  ""
{
  if (mips_legitimize_move (SFmode, operands[0], operands[1]))
    DONE;
}
)

(define_insn "*movsf_hardfloat"
[(set (match_operand:SF 0 "nonimmediate_operand" "=f,f,f,m,m,*f,*d,*d,*d,*m") (match_operand:SF 1 "move_operand" "f,G,m,f,G,*d,*f,*G*d,*m,*d") ) ]
  "TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "fmove,mtc,fpload,fpstore,store,mtc,mfc,move,load,store")
   (set_attr "mode" "SF")]
)

(define_insn "*movsf_softfloat"
[(set (match_operand:SF 0 "nonimmediate_operand" "=d,d,m") (match_operand:SF 1 "move_operand" "Gd,m,d") ) ]
  "TARGET_SOFT_FLOAT && !TARGET_MIPS16
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,load,store")
   (set_attr "mode" "SF")]
)

(define_insn "*movsf_mips16"
[(set (match_operand:SF 0 "nonimmediate_operand" "=d,y,d,d,m") (match_operand:SF 1 "move_operand" "d,d,y,m,d") ) ]
  "TARGET_MIPS16
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,move,move,load,store")
   (set_attr "mode" "SF")]
)


(define_expand "movdf"
[(set (match_operand:DF 0 "" "") (match_operand:DF 1 "" "") ) ]
  ""
{
  if (mips_legitimize_move (DFmode, operands[0], operands[1]))
    DONE;
}
)

(define_insn "*movdf_hardfloat"
[(set (match_operand:DF 0 "nonimmediate_operand" "=f,f,f,m,m,*f,*d,*d,*d,*m") (match_operand:DF 1 "move_operand" "f,G,m,f,G,*d,*f,*d*G,*m,*d") ) ]
  "TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "fmove,mtc,fpload,fpstore,store,mtc,mfc,move,load,store")
   (set_attr "mode" "DF")]
)

(define_insn "*movdf_softfloat"
[(set (match_operand:DF 0 "nonimmediate_operand" "=d,d,m") (match_operand:DF 1 "move_operand" "dG,m,dG") ) ]
  "(TARGET_SOFT_FLOAT || TARGET_SINGLE_FLOAT) && !TARGET_MIPS16
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,load,store")
   (set_attr "mode" "DF")]
)

(define_insn "*movdf_mips16"
[(set (match_operand:DF 0 "nonimmediate_operand" "=d,y,d,d,m") (match_operand:DF 1 "move_operand" "d,d,y,m,d") ) ]
  "TARGET_MIPS16
   && (register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "move,move,move,load,store")
   (set_attr "mode" "DF")]
)


(define_expand "movti"
[(set (match_operand:TI 0 "" "") (match_operand:TI 1 "" "") ) ]
  "TARGET_64BIT"
{
  if (mips_legitimize_move (TImode, operands[0], operands[1]))
    DONE;
}
)

(define_insn "*movti"
[(set (match_operand:TI 0 "nonimmediate_operand" "=d,d,d,m,*a,*d") (match_operand:TI 1 "move_operand" "d,i,m,dJ,*d*J,*a") ) ]
  "TARGET_64BIT
   && !TARGET_MIPS16
   && (register_operand (operands[0], TImode)
       || reg_or_0_operand (operands[1], TImode))"
  "#"
  [(set_attr "move_type" "move,const,load,store,mthilo,mfhilo")
   (set_attr "mode" "TI")]
)

(define_insn "*movti_mips16"
[(set (match_operand:TI 0 "nonimmediate_operand" "=d,y,d,d,d,d,m,*d") (match_operand:TI 1 "move_operand" "d,d,y,K,N,m,d,*a") ) ]
  "TARGET_64BIT
   && TARGET_MIPS16
   && (register_operand (operands[0], TImode)
       || register_operand (operands[1], TImode))"
  "#"
  [(set_attr "move_type" "move,move,move,const,constN,load,store,mfhilo")
   (set_attr "mode" "TI")]
)


(define_expand "movtf"
[(set (match_operand:TF 0 "" "") (match_operand:TF 1 "" "") ) ]
  "TARGET_64BIT"
{
  if (mips_legitimize_move (TFmode, operands[0], operands[1]))
    DONE;
}
{:
)

(define_insn "*movtf"
[(set (match_operand:TF 0 "nonimmediate_operand" "=d,d,m,f,d,f,m") (match_operand:TF 1 "move_operand" "dG,m,dG,dG,f,m,f") ) ]
  "TARGET_64BIT
   && !TARGET_MIPS16
   && (register_operand (operands[0], TFmode)
       || reg_or_0_operand (operands[1], TFmode))"
  "#"
  [(set_attr "move_type" "move,load,store,mtc,mfc,fpload,fpstore")
   (set_attr "mode" "TF")]
)

(define_insn "*movtf_mips16"
[(set (match_operand:TF 0 "nonimmediate_operand" "=d,y,d,d,m") (match_operand:TF 1 "move_operand" "d,d,y,m,d") ) ]
  "TARGET_64BIT
   && TARGET_MIPS16
   && (register_operand (operands[0], TFmode)
       || register_operand (operands[1], TFmode))"
  "#"
  [(set_attr "move_type" "move,move,move,load,store")
   (set_attr "mode" "TF")]
)

(define_split 
[(set (match_operand:MOVE64 0 "nonimmediate_operand" "") (match_operand:MOVE64 1 "move_operand" "") ) ]
  "reload_completed && !TARGET_64BIT
   && mips_split_64bit_move_p (operands[0], operands[1])"
[  (const_int 0) ]
{
  mips_split_doubleword_move (operands[0], operands[1]);
  DONE;
}
)

(define_split 
[(set (match_operand:MOVE128 0 "nonimmediate_operand" "") (match_operand:MOVE128 1 "move_operand" "") ) ]
  "TARGET_64BIT && reload_completed"
[  (const_int 0) ]
{
  mips_split_doubleword_move (operands[0], operands[1]);
  DONE;
}
)


(define_split 
[(set (match_operand 0 "d_operand" "") (match_operand 1 "const_int_operand" "") ) ]
  "TARGET_MIPS16 && reload_completed && INTVAL (operands[1]) < 0"
[  (set (match_dup 2) (match_dup 3) ) (set (match_dup 2) (neg:SI (match_dup 2) ) ) ])


{
  operands[2] = gen_lowpart (SImode, operands[0]);
  operands[3] = GEN_INT (-INTVAL (operands[1]));
}

(define_expand "movv2sf"
[(set (match_operand:V2SF 0 "" "") (match_operand:V2SF 1 "" "") ) ]
  "TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT"
{
  if (mips_legitimize_move (V2SFmode, operands[0], operands[1]))
    DONE;
}
)

(define_insn "*movv2sf"
[(set (match_operand:V2SF 0 "nonimmediate_operand" "=f,f,f,m,m,*f,*d,*d,*d,*m") (match_operand:V2SF 1 "move_operand" "f,YG,m,f,YG,*d,*f,*d*YG,*m,*d") ) ]
  "TARGET_HARD_FLOAT
   && TARGET_PAIRED_SINGLE_FLOAT
   && (register_operand (operands[0], V2SFmode)
       || reg_or_0_operand (operands[1], V2SFmode))"
  { return mips_output_move (operands[0], operands[1]); }
  [(set_attr "move_type" "fmove,mtc,fpload,fpstore,store,mtc,mfc,move,load,store")
   (set_attr "mode" "DF")]
)


(define_insn "mfhi<GPR:mode>_<HILO:mode>"
[(set (match_operand:GPR 0 "register_operand" "=d") (unspec:GPR [(match_operand:HILO 1 "hilo_operand" "x") (UNSPEC_MFHI) ) ) ]
  ""
  { return ISA_HAS_MACCHI ? "<GPR:d>macchi\t%0,%.,%." : "mfhi\t%0"; }
  [(set_attr "move_type" "mfhilo")
   (set_attr "mode" "<GPR:MODE>")]
)


(define_insn "mthi<GPR:mode>_<HILO:mode>"
[(set (match_operand:HILO 0 "register_operand" "=x") (unspec [(match_operand:GPR 1 "reg_or_0_operand" "dJ") (match_operand:GPR 2 "register_operand" "l") ) ) ]
  ""
  "mthi\t%z1"
  [(set_attr "move_type" "mthilo")
   (set_attr "mode" "SI")]
)


(define_expand "move_double_word_fpr<mode>"
[(set (match_operand:SPLITF 0 "" "") (match_operand:SPLITF 1 "" "") ) ]
  ""
{
  if (FP_REG_RTX_P (operands[0]))
    {
      rtx low = mips_subword (operands[1], 0);
      rtx high = mips_subword (operands[1], 1);
      emit_insn (gen_load_low<mode> (operands[0], low));
      if (TARGET_FLOAT64 && !TARGET_64BIT)
      	emit_insn (gen_mthc1<mode> (operands[0], high, operands[0]));
      else
	emit_insn (gen_load_high<mode> (operands[0], high, operands[0]));
    }
  else
    {
      rtx low = mips_subword (operands[0], 0);
      rtx high = mips_subword (operands[0], 1);
      emit_insn (gen_store_word<mode> (low, operands[1], const0_rtx));
      if (TARGET_FLOAT64 && !TARGET_64BIT)
	emit_insn (gen_mfhc1<mode> (high, operands[1]));
      else
	emit_insn (gen_store_word<mode> (high, operands[1], const1_rtx));
    }
  DONE;
}
)


(define_insn "load_low<mode>"
[(set (match_operand:SPLITF 0 "register_operand" "=f,f") (unspec:<HALFMODE> [(match_operand:<HALFMODE> 1 "general_operand" "dJ,m") (UNSPEC_LOAD_LOW) ) ) ]
  "TARGET_HARD_FLOAT"
{
  operands[0] = mips_subword (operands[0], 0);
  return mips_output_move (operands[0], operands[1]);
}
  [(set_attr "move_type" "mtc,fpload")
   (set_attr "mode" "<HALFMODE>")]
)


(define_insn "load_high<mode>"
[(set (match_operand:SPLITF 0 "register_operand" "=f,f") (unspec:<HALFMODE> [(match_operand:<HALFMODE> 1 "general_operand" "dJ,m") (UNSPEC_LOAD_HIGH) ) ) ]
  "TARGET_HARD_FLOAT"
{
  operands[0] = mips_subword (operands[0], 1);
  return mips_output_move (operands[0], operands[1]);
}
  [(set_attr "move_type" "mtc,fpload")
   (set_attr "mode" "<HALFMODE>")]
)


(define_insn "store_word<mode>"
[(set (match_operand:<HALFMODE> 0 "nonimmediate_operand" "=d,m") (unspec:<HALFMODE> [(match_operand:SPLITF 1 "register_operand" "f,f") (UNSPEC_STORE_WORD) ) ) ]
  "TARGET_HARD_FLOAT"
{
  operands[1] = mips_subword (operands[1], INTVAL (operands[2]));
  return mips_output_move (operands[0], operands[1]);
}
  [(set_attr "move_type" "mfc,fpstore")
   (set_attr "mode" "<HALFMODE>")]
)


(define_insn "mthc1<mode>"
[(set (match_operand:SPLitf 0 "register_operand" "=f") (unspec:SPLITF [(match_operand:<HALFMODE> 1 "reg_or_0_operand" "dJ") (UNSPEC_MTHC1) ) ) ]
  "TARGET_HARD_FLOAT && ISA_HAS_MXHC1"
  "mthc1\t%z1,%0"
  [(set_attr "move_type" "mtc")
   (set_attr "mode" "<HALFMODE>")]
)


(define_insn "mfhc1<mode>"
[(set (match_operand:<HALFMODE> 0 "register_operand" "=d") (unspec:<HALFMODE> [(match_operand:SPLITF 1 "register_operand" "f") ) ) ]
  "TARGET_HARD_FLOAT && ISA_HAS_MXHC1"
  "mfhc1\t%0,%1"
  [(set_attr "move_type" "mfc")
   (set_attr "mode" "<HALFMODE>")]
)


(define_expand "load_const_gp_<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (const:P (unspec:P [(const_int 0) ) ) ) ]
)


(define_insn_and_split "laodgp_newabi_<mode>"
[(set (match_operand:P 0 "register_operand" "=&d") (unspec:P [(match_operand:P 1 "" "") (match_operand:P 2 "register_operand" "d") ) ) ]
  "mips_current_loadgp_style () == LOADGP_NEWABI"
  { return mips_must_initialize_gp_p () ? "#" : ""; }
  "&& mips_must_initialize_gp_p ()"
[  (set (match_dup 0) (match_dup 3) ) (set (match_dup 0) (match_dup 4) ) (set (match_dup 0) (match_dup 6) ) ])


{
  operands[3] = gen_rtx_HIGH (Pmode, operands[1]);
  operands[4] = gen_rtx_PLUS (Pmode, operands[0], operands[2]);
  operands[5] = gen_rtx_LO_SUM (Pmode, operands[0], operands[1]);
}
  [(set_attr "type" "ghost")]

(define_insn_and_split "loadgp_absolute_<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (unspec:P [(match_operand:P 1 "" "") ) ) ]
  "mips_current_loadgp_style () == LOADGP_ABSOLUTE"
  { return mips_must_initialize_gp_p () ? "#" : ""; }
  "&& mips_must_initialize_gp_p ()"
[  (const_int 0) ]
{
  mips_emit_move (operands[0], operands[1]);
  DONE;
}
  [(set_attr "type" "ghost")]
)


(define_insn "loadgp_blockage"
[(unspec_volatile [(reg(reg:0) ) ]
  ""
  ""
  [(set_attr "type" "ghost")]
)


(define_insn_and_split "loadgp_rtp_<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (unspec:P [(match_operand:P 1 "symbol_ref_operand" "") (match_operand:P 2 "symbol_ref_operand" "") ) ) ]
  "mips_current_loadgp_style () == LOADGP_RTP"
  { return mips_must_initialize_gp_p () ? "#" : ""; }
  "&& mips_must_initialize_gp_p ()"
[  (set (match_dup 0) (high:P (match_dup 3) ) ) (set (match_dup 0) (unspec:P [(match_dup 0) (match_dup 3) ) ) (set (UNSPEC_LOAD_GOT) (unspec:P [(match_dup 0) (match_dup 0) (match_dup 4) ) ) (UNSPEC_LOAD_GOT) ]
{
  operands[3] = mips_unspec_address (operands[1], SYMBOL_ABSOLUTE);
  operands[4] = mips_unspec_address (operands[2], SYMBOL_HALF);
}
  [(set_attr "type" "ghost")]
)


(define_insn_and_split "copygp_mips16_<mode>"
[(set (match_operand:P 0 "register_operand" "=y") (unspec [(match_operand:P 1 "register_operand" "d") ) ) ]
  "TARGET_MIPS16"
  { return mips_must_initialize_gp_p () ? "#" : ""; }
  "&& mips_must_initialize_gp_p ()"
[ (set (match_dup 0) (match_dup 1) ) ]
  ""
  [(set_attr "type" "ghost")]
)


(define_insn_and_split "potential_cprestore_<mode>"
[ (set (match_operand:P 0 "cprestore_save_slot_operand" "=X,X") (unspec:P [(match_operand:P 1 "const_int_operand" "I,i") (match_operand:P 2 "register_operand" "d,d") ) ) (clobber (UNSPEC_POTENTIAL_CPRESTORE) ) (match_operand:P 3 "scratch_operand" "=X,&d") ]
  "!TARGET_CPRESTORE_DIRECTIVE || operands[2] == pic_offset_table_rtx"
  { return mips_must_initialize_gp_p () ? "#" : ""; }
  "mips_must_initialize_gp_p ()"
[  (const_int 0) ]
{
  mips_save_gp_to_cprestore_slot (operands[0], operands[1],
				  operands[2], operands[3]);
  DONE;
}
  [(set_attr "type" "ghost")]
)


(define_insn "cprestore_<mode>"
[(set (match_operand:P 0 "cprestore_save_slot_operand" "=X,X") (unspec:P [(match_operand:P 1 "const_int_operand" "I,i") (reg(reg:0) ) ) ]
  "TARGET_CPRESTORE_DIRECTIVE"
{
  if (mips_nomacro.nesting_level > 0 && which_alternative == 1)
    return ".set\tmacro\;.cprestore\t%1\;.set\tnomacro";
  else
    return ".cprestore\t%1";
}
  [(set_attr "type" "store")
   (set_attr "length" "4,12")]
)

(define_insn "use_cprestore_<mdoe>"
[(set (reg:P CPRESTORE_SLOT_REGNUM) (match_operand:P 0 "cprestore_load_slot_operand" "") ) ]
  ""
  ""
  [(set_attr "type" "ghost")]
)


(define_expand "clear_cache"
[  (match_operand 0 "pmode_register_operand" "")  (match_operand 1 "pmode_register_operand" "") ]
  ""
  "
{
  if (TARGET_SYNCI)
    {
      mips_expand_synci_loop (operands[0], operands[1]);
      emit_insn (gen_sync ());
      emit_insn (PMODE_INSN (gen_clear_hazard, ()));
    }
  else if (mips_cache_flush_func && mips_cache_flush_func[0])
    {
      rtx len = gen_reg_rtx (Pmode);
      emit_insn (gen_sub3_insn (len, operands[1], operands[0]));
      MIPS_ICACHE_SYNC (operands[0], len);
    }
  DONE;
}"
)

(define_insn "sync"
[(unspec_volatile [(const_int 0) ) ]
  "GENERATE_SYNC"
  { return mips_output_sync (); }
)

(define_insn "synci"
[(unspec_volatile [(match_operand 0 "pmode_register_operand" "d") ) ]
  "TARGET_SYNCI"
  "synci\t0(%0)"
)

(define_insn "rdhwr_synci_step_<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (unspec_volatile [(const_int 1) ) ) ]
  "ISA_HAS_SYNCI"
  "rdhwr\t%0,$1"
)

(define_insn "clear_hazard_<mode>"
[ (unspec_volatile [(const_int 0) ) (clobber (UNSPEC_CLEAR_HAZARD) ) (reg:P RETURN_ADDR_REGNUM) ]
  "ISA_HAS_SYNCI"
{
  return "%(%<bal\t1f\n"
         "\tnop\n"
         "1:\t<d>addiu\t$31,$31,12\n"
         "\tjr.hb\t$31\n"
         "\tnop%>%)";
}
  [(set_attr "length" "20")]
)


(define_insn "mips_cache"
[(set (mem:BLK (scratch) ) (unspec:BLK [(match_operand:SI 0 "const_int_operand" "") (match_operand:QI 1 "address_opeand" "p") ) ) ]
  "ISA_HAS_CACHE"
  "cache\t%X0,%a1"
)


(define_insn "r10k_cache_barrier"
[(set (mem:BLK (scratch) ) (unspec:BLK [(const_int 0) ) ) ]
  "ISA_HAS_CACHE"
  "cache\t0x14,0(%$)"
  [(set_attr "can_delay" "no")]
)



(define_expand "movmemsi"
[(parallel [(set (match_operand:BLK 0 "general_operand" "") (match_operand:BLK 1 "general_operand" "") ) (use (match_operand:SI 2 "" "") ) (use (match_operand:SI 3 "const_int_operand" "") ) ]) ]
  "!TARGET_MIPS16 && !TARGET_MEMCPY"
{
  if (mips_expand_block_move (operands[0], operands[1], operands[2]))
    DONE;
  else
    FAIL;
}
)



(define_expand "<optab><mode>3"
[(set (match_operand:GPR 0 "register_operand" "") (any_shift:GPR (match_operand:GPR 1 "register_operand" "") (match_operand:SI 2 "arith_operand" "") ) ) ]
  ""
{
  /* On the mips16, a shift of more than 8 is a four byte instruction,
     so, for a shift between 8 and 16, it is just as fast to do two
     shifts of 8 or less.  If there is a lot of shifting going on, we
     may win in CSE.  Otherwise combine will put the shifts back
     together again.  This can be called by mips_function_arg, so we must
     be careful not to allocate a new register if we've reached the
     reload pass.  */
  if (TARGET_MIPS16
      && optimize
      && CONST_INT_P (operands[2])
      && INTVAL (operands[2]) > 8
      && INTVAL (operands[2]) <= 16
      && !reload_in_progress
      && !reload_completed)
    {
      rtx temp = gen_reg_rtx (<MODE>mode);
      emit_insn (gen_<optab><mode>3 (temp, operands[1], GEN_INT (8)));
      emit_insn (gen_<optab><mode>3 (operands[0], temp,
				     GEN_INT (INTVAL (operands[2]) - 8)));
      DONE;
    }
}
)

(define_insn "*<optab><mode>3"
[(set (match_operand:GPR 0 "register_operand" "=d") (any_shift:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:SI 2 "arith_operand" "dI") ) ) ]
  "!TARGET_MIPS16"
{
  if (CONST_INT_P (operands[2]))
    operands[2] = GEN_INT (INTVAL (operands[2])
			   & (GET_MODE_BITSIZE (<MODE>mode) - 1));
  return "<d><insn>\t%0,%1,%2";
}
  [(set_attr "type" "shift")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*<opab>si3_extend"
[(set (match_operand:DI 0 "register_operand" "=d") (sign_extend:DI (any_shift:SI (match_operand:SI 1 "register_operand" "d") (match_operand:SI 2 "arith_operand" "dI") ) ) ) ]
  "TARGET_64BIT && !TARGET_MIPS16"
{
  if (CONST_INT_P (operands[2]))
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
  return "<insn>\t%0,%1,%2";
}
  [(set_attr "type" "shift")
   (set_attr "mode" "SI")]
)

(define_insn "*<optab>si3_mips16"
[(set (match_operand:SI 0 "register_operand" "=d,d") (any_shift:SI (match_operand:SI 1 "register_operand" "0,d") (match_operand:SI 2 "arith_operand" "d,I") ) ) ]
  "TARGET_MIPS16"
{
  if (which_alternative == 0)
    return "<insn>\t%0,%2";
  operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
  return "<insn>\t%0,%1,%2";
}
  [(set_attr "type" "shift")
   (set_attr "mode" "SI")
   (set_attr_alternative "length"
		[(const_int 4)
		 (if_then_else (match_operand 2 "m16_uimm3_b")
			       (const_int 4)
			       (const_int 8))])]
)


(define_insn "*ashld3_mips16"
[(set (match_operand:DI 0 "register_operand" "=d,d") (ashift:DI (match_operand:DI 1 "register_operand" "0,d") (match_operand:SI 2 "arith_operand" "d,I") ) ) ]
  "TARGET_64BIT && TARGET_MIPS16"
{
  if (which_alternative == 0)
    return "dsll\t%0,%2";
  operands[2] = GEN_INT (INTVAL (operands[2]) & 0x3f);
  return "dsll\t%0,%1,%2";
}
  [(set_attr "type" "shift")
   (set_attr "mode" "DI")
   (set_attr_alternative "length"
		[(const_int 4)
		 (if_then_else (match_operand 2 "m16_uimm3_b")
			       (const_int 4)
			       (const_int 8))])]
)

(define_insn "*ashrdi3_mips16"
[(set (match_operand:DI 0 "register_operand" "=d,d") (ashiftrt:DI (match_operand:DI 1 "register_operand" "0,0") (match_operand:SI 2 "arith_operand" "d,I") ) ) ]
  "TARGET_64BIT && TARGET_MIPS16"
{
  if (CONST_INT_P (operands[2]))
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x3f);
  return "dsra\t%0,%2";
}
  [(set_attr "type" "shift")
   (set_attr "mode" "DI")
   (set_attr_alternative "length"
		[(const_int 4)
		 (if_then_else (match_operand 2 "m16_uimm3_b")
			       (const_int 4)
			       (const_int 8))])]
)

(define_insn "*lshrdi3_mips16"
[(set (match_operand:DI 0 "register_operand" "=d,d") (lshiftrt:DI (match_operand:DI 1 "register_operand" "0,0") (match_operand:SI 2 "arith_operand" "d,I") ) ) ]
  "TARGET_64BIT && TARGET_MIPS16"
{
  if (CONST_INT_P (operands[2]))
    operands[2] = GEN_INT (INTVAL (operands[2]) & 0x3f);
  return "dsrl\t%0,%2";
}
  [(set_attr "type" "shift")
   (set_attr "mode" "DI")
   (set_attr_alternative "length"
		[(const_int 4)
		 (if_then_else (match_operand 2 "m16_uimm3_b")
			       (const_int 4)
			       (const_int 8))])]
)


(define_split 
[(set (match_operand:GPR 0 "d_operand" "") (any_shift:GPR (match_operand:GPR 1 "const_int_operand" "") ) ) ]
  "TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16"
[  (set (match_dup 0) (any_shift:GPR (match_dup 1) (const_int 8) ) ) (set (match_dup 0) (any_shift:GPR (match_dup 0) (match_dup 2) ) ) ]
  { operands[2] = GEN_INT (INTVAL (operands[2]) - 8); }
)


(define_insn_and_split ""
  [(set (match_operand:SI 0 "register_operand" "=d")
	(lshiftrt:SI (match_operand:SI 1 "memory_operand" "m")
		     (match_operand:SI 2 "immediate_operand" "I")))]
  "TARGET_MIPS16"
  "#"
  ""
  [(set (match_dup 0) (match_dup 1))
   (set (match_dup 0) (lshiftrt:SI (match_dup 0) (match_dup 2)))]
  ""
  [(set_attr "type"	"load")
   (set_attr "mode"	"SI")
   (set_attr "length"	"16")])
(define_insn "rotr<mode>3"
[(set (match_operand:GPR 0 "register_operand" "=d") (rotatert:GPR (match_operand:GPR 1 "register_operand" "d") (match_operand:SI 2 "arith_operand" "dI") ) ) ]
  "ISA_HAS_ROR"
{
  if (CONST_INT_P (operands[2]))
    gcc_assert (INTVAL (operands[2]) >= 0
		&& INTVAL (operands[2]) < GET_MODE_BITSIZE (<MODE>mode));
  return "<d>ror\t%0,%1,%2";
}
  [(set_attr "type" "shift")
   (set_attr "mode" "<MODE>")]
{:

)

(define_insn "*branch_fp"
[(set (pc) (if_then_else  (match_operator 1 "equality_operator" [  (match_operand:CC 2 "register_operator" "z") (const_int 0) ]) (label_ref (match_operand 0 "" "") ) (pc) ) ) ]
  "TARGET_HARD_FLOAT"
{
  return mips_output_conditional_branch (insn, operands,
					 MIPS_BRANCH ("b%F1", "%Z2%0"),
					 MIPS_BRANCH ("b%W1", "%Z2%0"));
}
  [(set_attr "type" "branch")]
)

(define_insn "*branch_fp_inverted"
[(set (pc) (if_then_else  (match_operator 1 "equality_operator" [  (match_operand:CC 2 "register_operand" "z") (const_int 0) ]) (pc) (label_ref (match_operand 0 "" "") ) ) ) ]
  "TARGET_HARD_FLOAT"
{
  return mips_output_conditional_branch (insn, operands,
					 MIPS_BRANCH ("b%W1", "%Z2%0"),
					 MIPS_BRANCH ("b%F1", "%Z2%0"));
}
  [(set_attr "type" "branch")]
)


(define_insn "*branch_order<mode>"
[(set (pc) (if_then_else  (match_operator 1 "order_operator" [  (match_operand:GPR 2 "register_operand" "d") (const_int 0) ]) (label_ref (match_operand 0 "" "") ) (pc) ) ) ]
  "!TARGET_MIPS16"
  { return mips_output_order_conditional_branch (insn, operands, false); }
  [(set_attr "type" "branch")]
)

(define_insn "*branch_order<mode>_inverted"
[(set (pc) (if_then_else  (match_operator 1 "order_operator" [  (match_operand:GPR 2 "register_operand" "d") (const_int 0) ]) (pc) (label_ref (match_operand 2 "" "") ) ) ) ]
  "!TARGET_MIPS16"
  { return mips_output_order_conditional_branch (insn, operands, true); }
  [(set_attr "type" "branch")]
)


(define_insn "*branch_equality<mode>"
[(set (pc) (if_then_else  (match_operator 1 "equality_operator" [  (match_operand:GPR 2 "register_operand" "d") (match_operand:GPR 3 "reg_or_0_operand" "dJ") (match_operand 0 "" "") (pc) ]) ) ) ]
  "!TARGET_MIPS16"
{
  return mips_output_conditional_branch (insn, operands,
					 MIPS_BRANCH ("b%C1", "%2,%z3,%0"),
					 MIPS_BRANCH ("b%N1", "%2,%z3,%0"));
}
  [(set_attr "type" "branch")]
)

(define_insn "*branch_equality<mode>_inverted"
[(set (pc) (if_then_else  (match_operator 1 "equality_operator" [  (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "reg_or_operand" "dJ") ]) (pc) (label_ref (match_operand 0 "" "") ) ) ) ]
  "!TARGET_MIPS16"
{
  return mips_output_conditional_branch (insn, operands,
					 MIPS_BRANCH ("b%N1", "%2,%z3,%0"),
					 MIPS_BRANCH ("b%C1", "%2,%z3,%0"));
}
  [(set_attr "type" "branch")]
)


(define_insn "*branch_equality<mode>_mips16"
[(set (pc) (if_then_else  (match_operator 0 "equality_operator" [  (match_operand:GPR 1 "register_operand" "d,t") (const_int 0) ]) (match_operand 2 "pc_or_label_operand" "") (match_operand 3 "pc_or_label_operand" "") ) ) ]
  "TARGET_MIPS16"
{
  if (operands[2] != pc_rtx)
    {
      if (which_alternative == 0)
	return "b%C0z\t%1,%2";
      else
	return "bt%C0z\t%2";
    }
  else
    {
      if (which_alternative == 0)
	return "b%N0z\t%1,%3";
      else
	return "bt%N0z\t%3";
    }
}
  [(set_attr "type" "branch")]
)

(define_insn "cbranch<mode>4"
[(set (pc) (if_then_else  (match_operator 0 "comparison_operator" [  (match_operand:GPR 1 "register_operand" "") (match_operand:GPR 2 "nonmemory_operand" "") ]) (label_ref (match_operand 3 "" "") ) (pc) ) ) ]
  ""
{
  mips_expand_conditional_branch (operands);
  DONE;
}
)

(define_expand "cbranch<mode>4"
[(set (pc) (if_then_else  (match_operator 0 "comparison_operator" [  (match_operand:SCALARAF 1 "register_operand" "") (match_operand:SCALARF 2 "register_operand" "") ]) (label_ref (match_operand 3 "" "") ) (pc) ) ) ]
  ""
{
  mips_expand_conditional_branch (operands);
  DONE;
}
)


(define_expand "condjump"
[(set (pc) (if_then_else (match_operand 0 "" "") (label_ref (match_operand 1 "" "") ) (pc) ) ) ]
)


(define_insn "*branch_bit<bbv><mode>"
[(set (pc) (if_then_else (equality_op (zero_extract (match_operand:GPR 1 "register_operand" "d") (const_int 1) (match_operand 2 "const_int_operand" "") ) (const_int 0) ) (label_ref (match_operand 0 "" "") ) (pc) ) ) ]
  "ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (<MODE>mode)"
{
  return
    mips_output_conditional_branch (insn, operands,
				    MIPS_BRANCH ("bbit<bbv>", "%1,%2,%0"),
				    MIPS_BRANCH ("bbit<bbinv>", "%1,%2,%0"));
}
  [(set_attr "type"	     "branch")
   (set_attr "branch_likely" "no")]
)

(define_insn "*branch_bit<bbv><mode>_inverted"
[(set (pc) (if_then_else (equality_op (zero_extract (match_operand:GPR 1 "register_operand" "d") (const_int 1) (match_operand 2 "const_int_operand" "") ) (const_int 0) ) (pc) (label_ref (match_operand 0 "" "") ) ) ) ]
  "ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (<MODE>mode)"
{
  return
    mips_output_conditional_branch (insn, operands,
				    MIPS_BRANCH ("bbit<bbinv>", "%1,%2,%0"),
				    MIPS_BRANCH ("bbit<bbv>", "%1,%2,%0"));
}
  [(set_attr "type"	     "branch")
   (set_attr "branch_likely" "no")]
)



(define_expand "cstore<mode>4"
[(set (match_operand:SI 0 "register_operand" "") (match_operator:SI 1 "mips_cstore_operator" [ (match_operand:GPR 2 "register_operand" "") (match_operand:GPR 3 "nonmemory_operand" "") ]) ) ]
  ""
{
  mips_expand_scc (operands);
  DONE;
}
)

(define_insn "*seq_zero_<GPR:mode><GPR2:mode>"
[(set (match_operand:GPR 0 "register_opreand" "=d") (eq:GPR2 (match_operand:GPR 1 "register_operand" "d") (const_int 0) ) ) ]
  "!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE"
  "sltu\t%0,%1,1"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*seq_zero_<GPR:mode><GPR2:mode>_mips16"
[(set (match_operand:GPR 0 "register_opreand" "=t") (eq:GPR2 (match_operand:GPR 1 "register_operand" "d") (const_int 0) ) ) ]
  "TARGET_MIPS16 && !ISA_HAS_SEQ_SNE"
  "sltu\t%1,1"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)


(define_insn "*seq_zero_<GPR:mode><GPR2:mode>"
[(set (match_operand:GPR 0 "register_operad" "=d,d,d") (eq:GPR2 (match_operand:GPR 1 "register_operand" "%d,d,d") (match_operand:GPR 2 "reg_imm10_operand" "d,J,YB") ) ) ]
  "ISA_HAS_SEQ_SNE"
  "@
   seq\t%0,%1,%2
   sltiu\t%0,%1,1
   seqi\t%0,%1,%2"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*sne_zero_<GPR:mode><GPR2:mode>"
[(set (match_operand:GPR2 0 "register_operand" "=d") (ne:GPR2 (match_operand:GPR 1 "register_operand" "d") (const_int 0) ) ) ]
  "!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE"
  "sltu\t%0,%.,%1"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)


(define_insn "*sne_<GPR:mode><GPR2:mode>_sne"
[(set (match_operand:GPR2 0 "register_operand" "=d,d,d") (ne:GPR2 (match_operand:GPR 1 "regiser_operand" "%d,d,d") (match_operand:GPR 2 "reg_imm10_operand" "d,J,YB") ) ) ]
  "ISA_HAS_SEQ_SNE"
  "@
   sne\t%0,%1,%2
   sltu\t%0,%.,%1
   snei\t%0,%1,%2"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*sgt<u>_<GPR:mode><GPR2:mode>"
[(set (match_operand:GPR2 0 "register_operand" "=d") (any_gt:GPR2 (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "reg_or_0_operand" "dJ") ) ) ]
  "!TARGET_MIPS16"
  "slt<u>\t%0,%z2,%1"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*sgt<u>_<GPR:mode><GPR2:mode>_mips16"
[(set (match_operand:GPR2 0 "register_operand" "=t") (any_gt:GPR2 (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "register_operand" "d") ) ) ]
  "TARGET_MIPS16"
  "slt<u>\t%2,%1"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*sge<u>_<GPR:mode><GPR2:mode>"
[(set (match_operand:GPR2 0 "register_operand" "=d") (any_ge:GPR (match_operand:GPR 1 "register_operand" "d") (const_int 1) ) ) ]
  "!TARGET_MIPS16"
  "slt<u>\t%0,%.,%1"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*slt<u>_<GPR:mode><GPR2:mode>"
[(set (match_operand:GPR2 0 "register_operand" "=d") (any_lt:GPR2 (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "arith_operand" "dI") ) ) ]
  "!TARGET_MIPS16"
  "slt<u>\t%0,%1,%2"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*slt<u>_<GPR:mode><GPR2:mode>_mips16"
[(set (match_operand:GPR2 0 "register_operand" "=t,t") (any_lt:GPR2 (match_operand:GPR 1 "register_operand" "d,d") (match_operand:GPR 2 "arith_operand" "d,I") ) ) ]
  "TARGET_MIPS16"
  "slt<u>\t%1,%2"
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")
   (set_attr_alternative "length"
		[(const_int 4)
		 (if_then_else (match_operand 2 "m16_uimm8_1")
			       (const_int 4)
			       (const_int 8))])]
)

(define_insn "*sle<u>_<GPR:mode><GPR2:mode>"
[(set (match_operand:GPR2 0 "register_operand" "=d") (any_le:GPR2 (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "sle_operand" "") ) ) ]  
  "!TARGET_MIPS16"
{
  operands[2] = GEN_INT (INTVAL (operands[2]) + 1);
  return "slt<u>\t%0,%1,%2";
}
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*sle<u>_<GPR:mode><GPR2:mode>_mips16"
[(set (match_operand:GPR2 0 "register_operand" "=t") (any_le:GPR2 (match_operand:GPR 1 "register_operand" "d") (match_operand:GPR 2 "sle_operand" "") ) ) ]
  "TARGET_MIPS16"
{
  operands[2] = GEN_INT (INTVAL (operands[2]) + 1);
  return "slt<u>\t%1,%2";
}
  [(set_attr "type" "slt")
   (set_attr "mode" "<GPR:MODE>")
   (set (attr "length") (if_then_else (match_operand 2 "m16_uimm8_m1_1")
				      (const_int 4)
				      (const_int 8)))]
)



(define_insn "s<code>_<mode>"
[(set (match_operand:CC 0 "register_operand" "=z") (fcond:CC (match_operand:SCALARF 1 "register_operand" "f") (match_operand:SCALARF 2 "register_operand" "f") ) ) ]
  ""
  "c.<fcond>.<fmt>\t%Z0%1,%2"
  [(set_attr "type" "fcmp")
   (set_attr "mode" "FPSW")]
)

(define_insn "s<code>_<mode>"
[(set (match_operand:CC 0 "register_operand" "=z") (fcond:CC (match_operand:SCALARF 1 "register_operand" "f") (match_operand:SCALARF 2 "register_operand" "f") ) ) ]
  ""
  "c.<swapped_fcond>.<fmt>\t%Z0%2,%1"
  [(set_attr "type" "fcmp")
   (set_attr "mode" "FPSW")]
)



(define_expand "jump"
[(set (pc) (label_ref (match_operand 0 "" "") ) ) ]
)

(define_expand "*jump_absolute"
[(set (pc) (label_ref (match_operand 0 "" "") ) ) ]
  "!TARGET_MIPS16 && TARGET_ABSOLUTE_JUMPS"
  { return MIPS_ABSOLUTE_JUMP ("%*j\t%l0%/"); }
  [(set_attr "type" "jump")]
)

(define_expand "*jump_pic"
[(set (pc) (label_ref (match_operand 0 "" "") ) ) ]
  "!TARGET_MIPS16 && !TARGET_ABSOLUTE_JUMPS"
{
  if (get_attr_length (insn) <= 8)
    return "%*b\t%l0%/";
  else
    {
      mips_output_load_label (operands[0]);
      return "%*jr\t%@%/%]";
    }
}
  [(set_attr "type" "branch")]
)


(define_expand "*jump_mips16"
[(set (pc) (label_ref (match_operand 0 "" "") ) ) ]
  "TARGET_MIPS16"
  "b\t%l0"
  [(set_attr "type" "branch")]
)

(define_expand "indirect_jump"
[(set (pc) (match_operand 0 "register_operand" "") ) ]
  ""
{
  operands[0] = force_reg (Pmode, operands[0]);
  emit_jump_insn (PMODE_INSN (gen_indirect_jump, (operands[0])));
  DONE;
}
)

(define_insn "indirect_jump_<mode>"
[(set (pc) (match_operand:P 0 "register_operand" "d") ) ]
  ""
  "%*j\t%0%/"
  [(set_attr "type" "jump")
   (set_attr "mode" "none")]
)

(define_expand "tablejump"
[ (set (pc) (match_operand 0 "register_operand" "") ) (use (match_operand 1 "" "") ) ]
  ""
{
  if (TARGET_MIPS16_SHORT_JUMP_TABLES)
    operands[0] = expand_binop (Pmode, add_optab,
				convert_to_mode (Pmode, operands[0], false),
				gen_rtx_LABEL_REF (Pmode, operands[1]),
				0, 0, OPTAB_WIDEN);
  else if (TARGET_GPWORD)
    operands[0] = expand_binop (Pmode, add_optab, operands[0],
				pic_offset_table_rtx, 0, 0, OPTAB_WIDEN);
  else if (TARGET_RTP_PIC)
    {
      /* When generating RTP PIC, we use case table entries that are relative
	 to the start of the function.  Add the function's address to the
	 value we loaded.  */
      rtx start = get_hard_reg_initial_val (Pmode, PIC_FUNCTION_ADDR_REGNUM);
      operands[0] = expand_binop (ptr_mode, add_optab, operands[0],
				  start, 0, 0, OPTAB_WIDEN);
    }
  emit_jump_insn (PMODE_INSN (gen_tablejump, (operands[0], operands[1])));
  DONE;
}
)

(define_insn "tablejump_<mode>"
[ (set (pc) (match_operand:P 0 "register_operand" "d") ) (use (match_operand 1 "" "") ) ]
  ""
  "%*j\t%0%/"
  [(set_attr "type" "jump")
   (set_attr "mode" "none")]
)


(define_expand "builtin_setjmp_setup"
[(use (match_operand 0 "register_operand" "") ) ]
  "TARGET_USE_GOT"
{
  rtx addr;
  addr = plus_constant (operands[0], GET_MODE_SIZE (Pmode) * 3);
  mips_emit_move (gen_rtx_MEM (Pmode, addr), pic_offset_table_rtx);
  DONE;
}
)


(define_expand "builtin_longjmp"
[(use (match_operand 0 "register_operand" "") ) ]
  "TARGET_USE_GOT"
{
  /* The elements of the buffer are, in order:  */
  int W = GET_MODE_SIZE (Pmode);
  rtx fp = gen_rtx_MEM (Pmode, operands[0]);
  rtx lab = gen_rtx_MEM (Pmode, plus_constant (operands[0], 1*W));
  rtx stack = gen_rtx_MEM (Pmode, plus_constant (operands[0], 2*W));
  rtx gpv = gen_rtx_MEM (Pmode, plus_constant (operands[0], 3*W));
  rtx pv = gen_rtx_REG (Pmode, PIC_FUNCTION_ADDR_REGNUM);
  /* Use gen_raw_REG to avoid being given pic_offset_table_rtx.
     The target is bound to be using $28 as the global pointer
     but the current function might not be.  */
  rtx gp = gen_raw_REG (Pmode, GLOBAL_POINTER_REGNUM);
  /* This bit is similar to expand_builtin_longjmp except that it
     restores $gp as well.  */
  mips_emit_move (hard_frame_pointer_rtx, fp);
  mips_emit_move (pv, lab);
  emit_stack_restore (SAVE_NONLOCAL, stack);
  mips_emit_move (gp, gpv);
  emit_use (hard_frame_pointer_rtx);
  emit_use (stack_pointer_rtx);
  emit_use (gp);
  emit_indirect_jump (pv);
  DONE;
}
)



(define_expand "prologue"
[ (const_int 1) ]
  ""
{
  mips_expand_prologue ();
  DONE;
}
)


concrete blockage.insn instantiates unspec_volatile {
	root ((const_int:0), UNSPEC_BLOCKAGE);
}
{:
  ""
  ""
  [(set_attr "type" "ghost")
   (set_attr "mode" "none")]
(define_expand "epilogue"
[ (const_int 2) ]
  ""
{
  mips_expand_epilogue (false);
  DONE;
}
)

(define_expand "sibcall_epilogure"
[ (const_int 2) ]
  ""
{
  mips_expand_epilogue (true);
  DONE;
}
)


(define_expand "return"
  [(simple_return)]
  "mips_can_use_return_insn ()"
  { mips_expand_before_return (); })
(define_expand "simple_return"
  [(simple_return)]
  ""
  { mips_expand_before_return (); })
(define_insn "*<optab>"
  [(any_return)]
  ""
  "%*j\t$31%/"
  [(set_attr "type"	"jump")
   (set_attr "mode"	"none")])
(define_insn "<optab>_internal"
  [(any_return)
   (use (match_operand 0 "pmode_register_operand" ""))]
  ""
  "%*j\t%0%/"
  [(set_attr "type"	"jump")
   (set_attr "mode"	"none")])
(define_insn "mips_eret"
  [(return)
   (unspec_volatile [(const_int 0)] UNSPEC_ERET)]
  ""
  "eret"
  [(set_attr "type"	"trap")
   (set_attr "mode"	"none")])
(define_insn "mips_deret"
  [(return)
   (unspec_volatile [(const_int 0)] UNSPEC_DERET)]
  ""
  "deret"
  [(set_attr "type"	"trap")
   (set_attr "mode"	"none")])
(define_insn "mips_di"
  [(unspec_volatile [(const_int 0)] UNSPEC_DI)]
  ""
  "di"
  [(set_attr "type"	"trap")
   (set_attr "mode"	"none")])
(define_insn "mips_ehb"
  [(unspec_volatile [(const_int 0)] UNSPEC_EHB)]
  ""
  "ehb"
  [(set_attr "type"	"trap")
   (set_attr "mode"	"none")])
(define_insn "mips_rdpgpr"
  [(set (match_operand:SI 0 "register_operand" "=d")
	(unspec_volatile:SI [(match_operand:SI 1 "register_operand" "d")]
			    UNSPEC_RDPGPR))]
  ""
  "rdpgpr\t%0,%1"
  [(set_attr "type"	"move")
   (set_attr "mode"	"SI")])
(define_insn "cop0_move"
  [(set (match_operand:SI 0 "register_operand" "=B,d")
	(unspec_volatile:SI [(match_operand:SI 1 "register_operand" "d,B")]
			    UNSPEC_COP0))]
  ""
{ return mips_output_move (operands[0], operands[1]); }
  [(set_attr "type"	"mtc,mfc")
   (set_attr "mode"	"SI")])
(define_expand "eh_return"
  [(use (match_operand 0 "general_operand"))]
  ""
{
  if (GET_MODE (operands[0]) != word_mode)
    operands[0] = convert_to_mode (word_mode, operands[0], 0);
  if (TARGET_64BIT)
    emit_insn (gen_eh_set_lr_di (operands[0]));
  else
    emit_insn (gen_eh_set_lr_si (operands[0]));
  DONE;
})
(define_insn "eh_set_lr_si"
  [(unspec [(match_operand:SI 0 "register_operand" "d")] UNSPEC_EH_RETURN)
   (clobber (match_scratch:SI 1 "=&d"))]
  "! TARGET_64BIT"
  "#")
(define_insn "eh_set_lr_di"
  [(unspec [(match_operand:DI 0 "register_operand" "d")] UNSPEC_EH_RETURN)
   (clobber (match_scratch:DI 1 "=&d"))]
  "TARGET_64BIT"
  "#")
(define_split
  [(unspec [(match_operand 0 "register_operand")] UNSPEC_EH_RETURN)
   (clobber (match_scratch 1))]
  "reload_completed"
  [(const_int 0)]
{
  mips_set_return_address (operands[0], operands[1]);
  DONE;
})
(define_expand "exception_receiver"
  [(const_int 0)]
  "TARGET_USE_GOT"
{
  /* See the comment above load_call<mode> for details.  */
  emit_insn (gen_set_got_version ());
  /* If we have a call-clobbered $gp, restore it from its save slot.  */
  if (HAVE_restore_gp_si)
    emit_insn (gen_restore_gp_si ());
  else if (HAVE_restore_gp_di)
    emit_insn (gen_restore_gp_di ());
  DONE;
})
(define_expand "nonlocal_goto_receiver"
  [(const_int 0)]
  "TARGET_USE_GOT"
{
  /* See the comment above load_call<mode> for details.  */
  emit_insn (gen_set_got_version ());
  DONE;
})
(define_insn_and_split "restore_gp_<mode>"
  [(set (reg:P 28)
	(unspec_volatile:P [(const_int 0)] UNSPEC_RESTORE_GP))
   (clobber (match_scratch:P 0 "=&d"))]
  "TARGET_CALL_CLOBBERED_GP"
  "#"
  "&& epilogue_completed"
  [(const_int 0)]
{
  mips_restore_gp_from_cprestore_slot (operands[0]);
  DONE;
}
  [(set_attr "type" "ghost")])
(define_insn_and_split "move_gp<mode>"
  [(set (match_operand:GPR 0 "nonimmediate_operand" "=d,m")
  	(unspec:GPR [(match_operand:GPR 1 "move_operand" "m,d")]
		    UNSPEC_MOVE_GP))]
  ""
  { return mips_must_initialize_gp_p () ? "#" : ""; }
  "mips_must_initialize_gp_p ()"
  [(const_int 0)]
{
  mips_emit_move (operands[0], operands[1]);
  DONE;
}
  [(set_attr "type" "ghost")])

(define_insn "load_call<mode>"
[(set (match_operand:P 0 "register_operand" "=d") (unspec:P [(match_operand:P 1 "register_operand" "d") (match_operand:P 2 "immediate_operand" "") (reg:SI GOT_VERSION_REGNUM) (UNSPEC_LOAD_CALL) ) ) ]
  "TARGET_USE_GOT"
  "<load>\t%0,%R2(%1)"
  [(set_attr "got" "load")
   (set_attr "mode" "<MODE>")]
)

(define_insn "set_got_version"
[(set (reg:SI GOT_VERSION_REGNUM) (unspec_volatile:SI [(const_int 0) (UNSPEC_SET_GOT_VERSION) ) ) ]
  "TARGET_USE_GOT"
  ""
  [(set_attr "type" "ghost")]
)

(define_insn "update_got_version"
[(set (reg:SI GOT_VERSION_REGNUM) (unspec:SI [(reg:SI GOT_VERSION_REGNUM) (UNSPEC_UPDATE_GOT_VERSION) ) ) ]
  "TARGET_USE_GOT"
  ""
  [(set_attr "type" "ghost")]
)


(define_expand "sibcall"
[(parallel [(use (match_operand 0 "" "") ) (use (match_operand 1 "" "") ) (use (match_operand 2 "" "") ) (match_operand 3 "" "") ]) ]
  "TARGET_SIBCALLS"
{
  mips_expand_call (MIPS_CALL_SIBCALL, NULL_RTX, XEXP (operands[0], 0),
		    operands[1], operands[2], false);
  DONE;
}
)

(define_insn "sibcall_internal"
[(call (mem:SI (match_operand 0 "call_insn_operand" "j,S") ) (match_operand 1 "" "") ) ]
  "TARGET_SIBCALLS && SIBLING_CALL_P (insn)"
  { return MIPS_CALL ("j", operands, 0, 1); }
  [(set_attr "jal" "indirect,direct")
   (set_attr "jal_macro" "no")]
)

(define_expand "sibcall_value"
[(parallel [(set (match_operand 0 "" "") (call (match_operand 1 "" "") (match_operand 2 "" "") ) ) (use (match_operand 3 "" "") ) ]) ]
  "TARGET_SIBCALLS"
{
  mips_expand_call (MIPS_CALL_SIBCALL, operands[0], XEXP (operands[1], 0),
		    operands[2], operands[3], false);
  DONE;
}
)

(define_insn "sibcall_value_internal"
[(set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "call_insn_operand" "j,S") ) (match_operand 2 "" "") ) ) ]
  "TARGET_SIBCALLS && SIBLING_CALL_P (insn)"
  { return MIPS_CALL ("j", operands, 1, 2); }
  [(set_attr "jal" "indirect,direct")
   (set_attr "jal_macro" "no")]
)

(define_insn "sibcall_value_multiple_internal"
[ (set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "call_insn_operand" "j,S") ) (match_operand 2 "" "") ) ) (set (match_operand 3 "register_operand" "") (call (mem:SI (match_dup 1) ) (match_dup 2) ) ) ]
  "TARGET_SIBCALLS && SIBLING_CALL_P (insn)"
  { return MIPS_CALL ("j", operands, 1, 2); }
  [(set_attr "jal" "indirect,direct")
   (set_attr "jal_macro" "no")]
)

(define_expand "call"
[(parallel [(use (match_operand 0 "" "") ) (use (match_operand 1 "" "") ) (use (match_operand 2 "" "") ) (match_operand 3 "" "") ]) ]
  ""
{
  mips_expand_call (MIPS_CALL_NORMAL, NULL_RTX, XEXP (operands[0], 0),
		    operands[1], operands[2], false);
  DONE;
}
)


(define_insn_and_split "call_internal"
[ (call (mem:SI (match_operand 0 "call_insn_operand" "c,S") ) (match_operand 1 "" "") ) (clobber (reg:SI RETURN_ADDR_REGNUM) ) ]
  ""
  { return TARGET_SPLIT_CALLS ? "#" : MIPS_CALL ("jal", operands, 0, 1); }
  "reload_completed && TARGET_SPLIT_CALLS"
[  (const_int 0) ]
{
  mips_split_call (curr_insn, gen_call_split (operands[0], operands[1]));
  DONE;
}
  [(set_attr "jal" "indirect,direct")]
)

(define_insn "call_split"
[ (call (mem:SI (match_operand 0 "call_insn_operand" "c,S") ) (match_operand 1 "" "") ) (clobber (reg:SI RETURN_ADDR_REGNUM) ) (clobber (reg(reg:0) ) ]
  "TARGET_SPLIT_CALLS"
  { return MIPS_CALL ("jal", operands, 0, 1); }
  [(set_attr "jal" "indirect,direct")
   (set_attr "jal_macro" "no")]
)


(define_insn_and_split "call_internal_direct"
[ (call (mem (match_operand 0 "const_call_insn_operand" "") ) (match_operand 1 "" "") )  (const_int 1) (clobber (reg:SI RETURN_ADDR_REGNUM) ) ]
  ""
  { return TARGET_SPLIT_CALLS ? "#" : MIPS_CALL ("jal", operands, 0, -1); }
  "reload_completed && TARGET_SPLIT_CALLS"
[  (const_int 0) ]
{
  mips_split_call (curr_insn,
		   gen_call_direct_split (operands[0], operands[1]));
  DONE;
}
  [(set_attr "jal" "direct")]
)

(define_insn "call_direct_split"
[ (call (mem:SI (match_operand 0 "const_call_insn_operand" "") ) (match_operand 1 "" "") )  (const_int 1) (clobber (reg:SI RETURN_ADDR_REGNUM) ) (clobber (reg(reg:0) ) ]
  "TARGET_SPLIT_CALLS"
  { return MIPS_CALL ("jal", operands, 0, -1); }
  [(set_attr "jal" "direct")
   (set_attr "jal_macro" "no")]
)

(define_expand "call_value"
[(parallel [(set (match_operand 0 "" "") (call (match_operand 1 "" "") (match_operand 2 "" "") ) ) (use (match_operand 3 "" "") ) ]) ]
  ""
{
  mips_expand_call (MIPS_CALL_NORMAL, operands[0], XEXP (operands[1], 0),
		    operands[2], operands[3], false);
  DONE;
}
)


(define_insn_and_split "call_value_internal"
[ (set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "call_insn_operand" "c,S") ) (match_operand 2 "" "") ) ) ]
  ""
  { return TARGET_SPLIT_CALLS ? "#" : MIPS_CALL ("jal", operands, 1, 2); }
  "reload_completed && TARGET_SPLIT_CALLS"
[  (const_int 0) ]
{
  mips_split_call (curr_insn,
		   gen_call_value_split (operands[0], operands[1],
					 operands[2]));
  DONE;
}
  [(set_attr "jal" "indirect,direct")]
)

(define_insn "call_value_split"
[ (set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "call_insn_operand" "c,S") ) (match_operand 2 "" "") ) ) (clobber (reg:SI RETURN_ADDR_REGNUM) ) (clobber (reg(reg:0) ) ]
  "TARGET_SPLIT_CALLS"
  { return MIPS_CALL ("jal", operands, 1, 2); }
  [(set_attr "jal" "indirect,direct")
   (set_attr "jal_macro" "no")]
)


(define_insn_and_split "call_value_internal_direct"
[ (set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "const_call_insn_operand" "") ) (match_operand 2 "" "") ) ) ]
  ""
  { return TARGET_SPLIT_CALLS ? "#" : MIPS_CALL ("jal", operands, 1, -1); }
  "reload_completed && TARGET_SPLIT_CALLS"
[  (const_int 0) ]
{
  mips_split_call (curr_insn,
		   gen_call_value_direct_split (operands[0], operands[1],
						operands[2]));
  DONE;
}
  [(set_attr "jal" "direct")]
)

(define_insn "call_value_direct_split"
[ (set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "const_call_insn_operand" "") ) (match_operand 2 "" "") ) )  (const_int 1) (clobber (reg:SI RETURN_ADDR_REGNUM) ) (clobber (reg(reg:0) ) ]
  "TARGET_SPLIT_CALLS"
  { return MIPS_CALL ("jal", operands, 1, -1); }
  [(set_attr "jal" "direct")
   (set_attr "jal_macro" "no")]
)


(define_insn_and_split "call_value_multiple_internal"
[ (set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "call_insn_operand" "c,S") ) (match_operand 2 "" "") ) ) (set (match_operand 3 "register_operand" "") (call (mem:SI (match_dup 1) ) (match_dup 2) ) ) (clobber (reg:SI RETURN_ADDR_REGNUM) ) ]
  ""
  { return TARGET_SPLIT_CALLS ? "#" : MIPS_CALL ("jal", operands, 1, 2); }
  "reload_completed && TARGET_SPLIT_CALLS"
[  (const_int 0) ]
{
  mips_split_call (curr_insn,
		   gen_call_value_multiple_split (operands[0], operands[1],
						  operands[2], operands[3]));
  DONE;
}
  [(set_attr "jal" "indirect,direct")]
)

(define_insn "call_value_multiple_split"
[ (set (match_operand 0 "register_operand" "") (call (mem:SI (match_operand 1 "call_insn_operand" "c,S") ) (match_operand 2 "" "") ) ) (set (match_operand 3 "register_operand" "") (call (mem:SI (match_dup 1) ) (duplicate2) ) ) (clobber (reg:SI RETURN_ADDR_REGNUM) ) (clobber (reg(reg:0) ) ]
  "TARGET_SPLIT_CALLS"
  { return MIPS_CALL ("jal", operands, 1, 2); }
  [(set_attr "jal" "indirect,direct")
   (set_attr "jal_macro" "no")]
)


(define_expand "untyped_call"
[(parallel [(call (match_operand 0 "" "") (const_int 0) )  (match_operand 1 "" "")  (match_operand 2 "" "") ]) ]
  ""
{
  int i;
  emit_call_insn (GEN_CALL (operands[0], const0_rtx, NULL, const0_rtx));
  for (i = 0; i < XVECLEN (operands[2], 0); i++)
    {
      rtx set = XVECEXP (operands[2], 0, i);
      mips_emit_move (SET_DEST (set), SET_SRC (set));
    }
  emit_insn (gen_blockage ());
  DONE;
}
)



(define_insn "prefetch"
[(prefetch (match_operand:QI 0 "address_operand" "p") (match_operand 1 "const_int_operand" "n") (match_operand 2 "const_int_operand" "n") ) ]
  "ISA_HAS_PREFETCH && TARGET_EXPLICIT_RELOCS"
{
  if (TARGET_LOONGSON_2EF || TARGET_LOONGSON_3A)
    /* Loongson 2[ef] and Loongson 3a use load to $0 to perform prefetching.  */
    return "ld\t$0,%a0";
  operands[1] = mips_prefetch_cookie (operands[1], operands[2]);
  return "pref\t%1,%a0";
}
  [(set_attr "type" "prefetch")]
)

(define_insn "*prefetch_indexed_<mode>"
[(prefetch (plus:P (match_operand:P 0 "register_operand" "d") (match_operand:P 1 "register_operand" "d") ) (match_operand 2 "const_int_operand" "n") (match_operand 3 "const_int_operand" "n") ) ]
  "ISA_HAS_PREFETCHX && TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT"
{
  operands[2] = mips_prefetch_cookie (operands[2], operands[3]);
  return "prefx\t%2,%1(%0)";
}
  [(set_attr "type" "prefetchx")]
)

(define_insn "nop"
[ (const_int 0) ]
  ""
  "%(nop%)"
  [(set_attr "type"	"nop")
   (set_attr "mode"	"none")]
)


(define_insn "hazard_nop"
[ (const_int 1) ]
  ""
  {
    if (mips_noreorder.nesting_level > 0)
      return "nop";
    else
      return "#nop";
  }
  [(set_attr "type"	"nop")])
)



(define_insn "*mov<GPR:mode>_on_<MOVECC:mode>"
[(set (match_operand:GPR 0 "register_operand" "=d,d") (if_then_else:GPR  (match_operator 4 "equality_operator" [  (match_operand:MOVECC 2 "register_operand" "<MOVECC:reg>,<MOVECC:reg>") (const_int 0) ]) (match_operand:GPR 3 "reg_or_0_operand" "dJ,0") (match_operand:GPR 4 "reg_or_0_operand" "0,dJ") ) ) ]
  "ISA_HAS_CONDMOVE"
  "@
    mov%T4\t%0,%z2,%1
    mov%t4\t%0,%z3,%1"
  [(set_attr "type" "condmove")
   (set_attr "mode" "<GPR:MODE>")]
)

(define_insn "*mov<SCALARF:mode>_on_<MOVECC:mode>"
[(set (match_operand:SCALARF 0 "register_operand" "=f,f") (if_then_else:SCALARF  (match_operator 4 "equality_operator" [  (match_operand:MOVECC 2 "register_operand" "<MOVECC:reg>,<MOVECC:reg>") (const_int 0) ]) (match_operand:SCALARF 3 "reg_or_0_operand" "f,0") (match_operand:SCALARF 4 "reg_or_0_operand" "0,f") ) ) ]
  "ISA_HAS_FP_CONDMOVE"
  "@
    mov%T4.<fmt>\t%0,%2,%1
    mov%t4.<fmt>\t%0,%3,%1"
  [(set_attr "type" "condmove")
   (set_attr "mode" "<SCALARF:MODE>")]
)


(define_expand "mov<mode>cc"
[ (set (match_dup 4) (match_operand 0 "comparison_operator" "") ) (set (match_operand:GPR 1 "register_operand" "") (if_then_else:GPR (match_dup 5) (match_operand:GPR 2 "reg_or_0_operand" "") (match_operand:GPR 3 "reg_or_operand" "") ) ) ]
  "ISA_HAS_CONDMOVE"
{
  mips_expand_conditional_move (operands);
  DONE;
}
)

(define_expand "move<mode>cc"
[ (set (match_dup 4) (match_operand 0 "comparison_operator" "") ) (set (match_operand:SCALARF 1 "register_operand" "") (if_then_else:SCALARF (match_dup 5) (match_operand:SCALARF 2 "reg_or_0_operand" "") (match_operand:SCALARF 3 "reg_or_operand" "") ) ) ]
  "ISA_HAS_FP_CONDMOVE"
{
  mips_expand_conditional_move (operands);
  DONE;
}
)



(define_insn "consttable_tls_reloc"
[(unspec_volatile [(match_operand 0 "tls_reloc_operand" "") (match_operand 1 "const_int_operand" "") ) ]
  "TARGET_MIPS16_PCREL_LOADS"
  { return mips_output_tls_reloc_directive (&operands[0]); }
  [(set (attr "length") (symbol_ref "INTVAL (operands[1])"))]
)

(define_insn "consttable_int"
[(unspec_volatile [(match_operand 0 "consttable_operand" "") (match_operand 1 "const_int_operand" "") ) ]
  "TARGET_MIPS16"
{
  assemble_integer (operands[0], INTVAL (operands[1]),
		    BITS_PER_UNIT * INTVAL (operands[1]), 1);
  return "";
}
  [(set (attr "length") (symbol_ref "INTVAL (operands[1])"))]
)

(define_insn "consttable_float"
[(unspec_volatile [(match_operand 0 "consttable_operand" "") ) ]
  "TARGET_MIPS16"
{
  REAL_VALUE_TYPE d;
  gcc_assert (GET_CODE (operands[0]) == CONST_DOUBLE);
  REAL_VALUE_FROM_CONST_DOUBLE (d, operands[0]);
  assemble_real (d, GET_MODE (operands[0]),
		 GET_MODE_BITSIZE (GET_MODE (operands[0])));
  return "";
}
  [(set (attr "length")
	(symbol_ref "GET_MODE_SIZE (GET_MODE (operands[0]))"))]
)

(define_insn "align"
[(unspec_volatile [(match_operand 0 "const_int_operand" "") ) ]
  ""
  ".align\t%0"
  [(set (attr "length") (symbol_ref "(1 << INTVAL (operands[0])) - 1"))])
)

(define_split 
[ (match_operand 0 "small_data_pattern" "") ]
  "reload_completed"
[  (match_dup 0) ]
  { operands[0] = mips_rewrite_small_data (operands[0]); }
)


(define_insn "*mips16e_save_restore"
  [(match_parallel 0 ""
       [(set (match_operand:SI 1 "register_operand")
	     (plus:SI (match_dup 1)
		      (match_operand:SI 2 "const_int_operand")))])]
  "operands[1] == stack_pointer_rtx
   && mips16e_save_restore_pattern_p (operands[0], INTVAL (operands[2]), NULL)"
  { return mips16e_output_save_restore (operands[0], INTVAL (operands[2])); }
  [(set_attr "type" "arith")
   (set_attr "extended_mips16" "yes")])
(define_insn_and_split "tls_get_tp_<mode>"
[ (set (match_operand:P 0 "register_operand" "=d") (unspec:P [(const_int 0) ) ) (clobber (UNSPEC_TLS_GET_TP) ) (reg:P TLS_GET_TP_REGNUM) ]
  "HAVE_AS_TLS && !TARGET_MIPS16"
  "#"
  "&& reload_completed"
[  (set (reg:P TLS_GET_TP_REGNUM) (unspec:P [(const_int 0) ) ) (set (UNSPEC_TLS_GET_TIP) (match_dup 0) ) (reg:P TLS_GET_TP_REGNUM) ]
  ""
  [(set_attr "type" "unknown")
   ; Since rdhwr always generates a trap for now, putting it in a delay
   ; slot would make the kernel's emulation of it much slower.
   (set_attr "can_delay" "no")
   (set_attr "mode" "<MODE>")
   (set_attr "length" "8")]
)

(define_insn "*tls_get_tp_<mode>_split"
[(set (reg:P TLS_GET_TP_REGNUM) (unspec:P [(const_int 0) ) ) ]
  "HAVE_AS_TLS && !TARGET_MIPS16"
  ".set\tpush\;.set\tmips32r2\t\;rdhwr\t$3,$29\;.set\tpop"
  [(set_attr "type" "unknown")
   ; See tls_get_tp_<mode>
   (set_attr "can_delay" "no")
   (set_attr "mode" "<MODE>")]
)


(define_insn_and_split "tls_get_tp_mips16_<mode>"
[ (set (match_operand:P 0 "register_operand" "=d") (unspec [(match_operand:P 1 "call_insn_operand" "dS") ) ) (clobber (UNSPEC_TLS_GET_TP) ) (clobber (reg:P TLS_GET_TP_REGNUM) ) (clobber (reg:P PIC_FUNCTION_ADDR_REGNUM) ) (reg:P RETURN_ADDR_REGNUM) ]
  "HAVE_AS_TLS && TARGET_MIPS16"
  "#"
  "&& reload_completed"
[ (parallel [(set (reg:P TLS_GET_TP_REGNUM) (unspec:P [(match_dup 1) ) ) (clobber (UNSPEC_TLS_GET_TP) ) (clobber (reg:P PIC_FUNCTION_ADDR_REGNUM) ) (set (reg:P RETURN_ADDR_REGNUM) (match_dup 0) ) (reg:P TLS_GET_TP_REGNUM) ]) ]
  ""
  [(set_attr "type" "multi")
   (set_attr "length" "16")
   (set_attr "mode" "<MODE>")]
)

(define_insn "*tls_get_tp_mips16_call_<mode>"
[ (set (reg:P TLS_GET_TP_REGNUM) (unspec [(match_operand:P 0 "call_insn_operand" "dS") ) ) (clobber (UNSPEC_TLS_GET_TP) ) (clobber (reg:P PIC_FUNCTION_ADDR_REGNUM) ) (reg:P RETURN_ADDR_REGNUM) ]
  "HAVE_AS_TLS && TARGET_MIPS16"
  { return MIPS_CALL ("jal", operands, 0, -1); }
  [(set_attr "type" "call")
   (set_attr "length" "12")
   (set_attr "mode" "<MODE>")]
)



(include "sync.md")
(include "mips-ps-3d.md")
(include "mips-dsp.md")
(include "mips-dspr2.md")
(include "mips-fixed.md")
(include "loongson.md")
(define_c_enum "unspec" [
  UNSPEC_ADDRESS_FIRST
])
